Description
===========

The C Cipher Plugins are a C-language implementation of the default
block ciphers used by the OpenDOF C Object Access Library and the C
Object Stack.

----------

Build Instructions
===========

To use [CMake](http://www.cmake.org/) to build the project, create a
directory where the component will be built, and from that directory run
the following commands. (Each component will need a different directory)

- `cmake <path to component>`
- `cmake --build . --target install` [The period is required, --target install specifies that it will build and install to the default location.]

In some cases it may be necessary to specify the install location.  The first command can be replaced with the following to change the default install location:

- `cmake <path to component> -DCMAKE_INSTALL_PREFIX=<path to alternate install location>`

For more information on building this and other C-language projects, see <https://opendof.org/opendof-build-instructions-for-c/>

----------

Alternate Build Instructions
===========

Official distributions for this project are built using [Apache Ant](http://ant.apache.org/) and [Apache Ivy](http://ant.apache.org/ivy/). 
For more information see <https://opendof.org/opendof-build-process/>

----------

Build Prerequisites
===========

There are no build prerequisites.

----------

Run-time Prerequisites
===========

There are no additional run-time prerequisites, beyond the build prerequisites.

----------

How to Report an Issue
===========

Issues can be reported through the issue tracking system of the OpenDOF
Project at <https://issue.opendof.org>

Information on the process for reporting an issue can be found at
<https://opendof.org/report-an-issue>