Description
===========

The C Object Access Library (OAL) provides a general API developers can
use to write software that implements OpenDOF protocols.

----------

Build Instructions
===========

To use [CMake](http://www.cmake.org/) to build the project, create a
directory where the component will be built, and from that directory run
the following commands. (Each component will need a different directory)

- `cmake <path to component>`
- `cmake --build . --target install` [The period is required, --target install specifies that it will build and install to the default location.]

In some cases it may be necessary to specify the install location.  The first command can be replaced with the following to change the default install location:

- `cmake <path to component> -DCMAKE_INSTALL_PREFIX=<path to alternate install location>`

For more information on building this and other C-language projects, see <https://opendof.org/opendof-build-instructions-for-c/>

----------

Alternate Build Instructions
===========

Official distributions for this project are built using [Apache Ant](http://ant.apache.org/) and [Apache Ivy](http://ant.apache.org/ivy/). 
For more information see <https://opendof.org/opendof-build-process/>

----------

Build Prerequisites
===========

- dof-pcr-dev
- PCR Implementation (e.g., dof-pcr for posix or dof-pcr for Windows)
- dof-cipher-plugins (optional, required for secure connections and
    servers)

----------

Runtime Prerequisites
===========

- PCR Implementation (e.g., dof-pcr for posix or dof-pcr for Windows)

----------

Additional Build instructions
===========

This project supports the Cmake find\_package command. The package name for this project is `dof-oal`. If the find\_package command is successfull the following Cmake variables will be set.

- `DOF_OAL_INCLUDE_DIRS`
- `DOF_OAL_LIBRARIES`
- `DOF_OAL_FOUND`

For more information see <https://opendof.org/opendof-build-instructions-for-c/>

----------

How to Report an Issue
===========

Issues can be reported through the issue tracking system of the OpenDOF
Project at <https://issue.opendof.org>

Information on the process for reporting an issue can be found at
<https://opendof.org/report-an-issue>.

