C Object Access Library (core-c-dof-oal) Release Information
====

### Version 7.1.7.3 ###

(2017-10-31, from path "dof-oal" at commit 9c5387c6ec7acf7d8f24c996089336c14bbcff48 on branch "patches-7.x" of repository core-c)

This release fixes the following issue:

- [COAL-118](https://issue.opendof.org/browse/COAL-118) A timer callback for a 49 day timeout may not get called if no timer items are added or time out for 49 days

More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.6.11 ###

(2017-10-18, from path "dof-oal" at commit db65eeed7eca4900616286325f8d97f1f05cf3bb on branch "patches-7.x" of repository core-c)

This release fixes the following issues:

- [COAL-106](https://issue.opendof.org/browse/COAL-106) Timer may not work after PCRTime_GetMS overflows
- [COAL-107](https://issue.opendof.org/browse/COAL-107) Timer may not call callback for all items when PCRTime_GetMS rolls over
- [COAL-108](https://issue.opendof.org/browse/COAL-108) A timer item may get inserted incorrectly after PCRTime_GetMS rolls over
- [COAL-110](https://issue.opendof.org/browse/COAL-110) Inserting a long timer item right after PCRTime_GetMS rolls over may not work correctly
- [COAL-111](https://issue.opendof.org/browse/COAL-111) DOFOperation_GetTimeRemaining will return 0 if more than 24 days remain
- [COAL-112](https://issue.opendof.org/browse/COAL-112) If PCRTime_GetMS rolls over, a server with a related server may not timeout correctly
- [COAL-113](https://issue.opendof.org/browse/COAL-113) DOF_CreateBridge may not time out correctly if PCRTime_GetMS rolls over
- [COAL-115](https://issue.opendof.org/browse/COAL-115) Cleanup for applications hang in DOF_Shutdown() and never finish or end up with error

More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.5.11 ###

(2017-01-25, from path "dof-oal" at commit dfab82d4631ab54fbd69f21d54fc93062fad13cd on branch "patches-7.x" of repository core-c)

This release fixes the following issues:

- [COAL-83](https://issue.opendof.org/browse/COAL-83) Exceptions are sent before the provide permission is checked.
- [COAL-90](https://issue.opendof.org/browse/COAL-90) Interest Operation is being lost after a duplicate is received
- [COAL-91](https://issue.opendof.org/browse/COAL-91) Provide operations can get deleted when only some interest is cancelled
- [COAL-92](https://issue.opendof.org/browse/COAL-92) DOFSystem_IsInterestRequested may fail if objectID attributes are used
- [COAL-93](https://issue.opendof.org/browse/COAL-93) Security Mode bug caused TEP Reject
- [COAL-94](https://issue.opendof.org/browse/COAL-94) Add a log message if a retry fails to get scheduled

More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.4.2 ###

(2016-04-26, from path "dof-oal" at commit 210e88e241fdb45d8ffbef801e858b6b374097c3 on branch "master" of repository core-c)

This release fixes the following issues:

- [COAL-65](https://issue.opendof.org/browse/COAL-65) TRP negotiation failure with multiple ciphers
- [COAL-72](https://issue.opendof.org/browse/COAL-72) CCM Security mode is not being negotiated correctly.

More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.3.3 ###

(2016-04-18, from path "dof-oal" at commit dbf6c45db68c37eec893930e2f408f7ce983cd82 on branch "master" of repository core-c)

This release fixes the following issues:

- [COAL-64](https://issue.opendof.org/browse/COAL-64) SourceID of type 15 causes failure
- [COAL-66](https://issue.opendof.org/browse/COAL-66) Static libraries don't build correctly for Windows
- [COAL-67](https://issue.opendof.org/browse/COAL-67) README.md has a typo for the name of the dof-cipher-plugins module.
- [COAL-68](https://issue.opendof.org/browse/COAL-68) Deprecated List references versions that aren't in ODP and lists a method that isn't deprecated.
- [COAL-69](https://issue.opendof.org/browse/COAL-69) In multiple pages of the OAL API docs, the oal.h file is listed in the Files section too many times.

More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.2.15 ###

(2016-02-07, from path "dof-oal" at commit face775cfec0c73025357be11c025c09862157bc on branch "master" of repository core-c)

This release fixes the following issues:

- [COAL-58](https://issue.opendof.org/browse/COAL-58) Reconnecting after a connection goes down causes increased memory usage
- [COAL-60](https://issue.opendof.org/browse/COAL-60) TEP timer item is not being destroyed in some cases
- [COAL-61](https://issue.opendof.org/browse/COAL-61) The introduction section of the C OAL docs has three trivial typos
- [COAL-62](https://issue.opendof.org/browse/COAL-62) Increased memory usage related to interest on new connections

More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.1.4 ###

(2015-11-24, from path "./dof-oal" at commit e4d07031535af1ea71f980c988ab3fdadf4b3ee5 on branch "master" of repository core-c)


This release fixes the following issue:

- [COAL-56](https://issue.opendof.org/browse/COAL-56) Connection fails to disconnect if hostname resolution fails


More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.1.0.14 ###

(2015-11-20, from path "./dof-oal" at commit 4979c62a47016bd1bc634feaaf43a3cf07dbfbcd on branch "master" of repository core-c)

This release adds the following DOFObject ID attributes:

- DOFOBJECTIDATTRIBUTE_BINDING_PROVIDER
- DOFOBJECTIDATTRIBUTE_RELATED_TIME
- DOFOBJECTIDATTRIBUTE_CREATED_TIME

This release adds the following DOFObject ID classes:

- DOFOBJECTIDCLASS_SMART_ENERGY_SYSTEM_SERIAL_NUMBER
- DOFOBJECTIDCLASS_AWS_RESOURCE_ID
- DOFOBJECTIDCLASS_IMEI
- DOFOBJECTIDCLASS_ODP_STRING
- DOFOBJECTIDCLASS_PANASONIC_SEBD_FUEL_CELL
- DOFOBJECTIDCLASS_ECHONET_LITE_NODE_ID

This release fixes the following issue:

- [COAL-52](https://issue.opendof.org/browse/COAL-52) Operations are sent over dead connection.


More information can be found on this project at [https://opendof.org/](https://opendof.org/).

----------

### Version 7.0.0.33 ###

(2015-07-28, from path "./dof-oal" at commit 9ad834f648bbc36d8c3964224303f577dae9c7df on branch "master" of repository core-c)

This is the initial public release of this project.

More information can be found on this project at [https://opendof.org/](https://opendof.org/).
