/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_SECURITYSCOPE_H
#define DOF_SECURITYSCOPE_H

#include <dof/core.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @defgroup DOFSecurityScope DOFSecurityScope
    @ingroup DOF_Framework

    Security scopes in the DOF govern how operations are routed and processed.  Only when an operation's security scope
    is compatible with a system, connection, or server can that operation be processed or sent to the system,
    connection, or server.  Compatibility of security scopes is discussed in the DOF Security Specification.

@{
**/


/**
 * Destroys a DOFSecurityScope.
 *
 * @param self The DOFSecurityScope to destroy.  If NULL, no action is taken.
 */
extern DOF_OAL_DECLSPEC void DOFSecurityScope_Destroy( DOFSecurityScope self );


/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* DOF_SECURITYSCOPE_H */
