/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_VALUE_GEN_H
#define DOF_VALUE_GEN_H

/* ** ** THIS FILE IS GENERATED!  DO NOT EDIT! ** ** */

#include <dof/core.h>

#ifdef  __cplusplus
extern "C" {
#endif


/**
    Create a new @ref DOFValue to hold a single value of type @ref int8.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref int8 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref int8.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueInt8_Create( int8 val );

/**
    Create the native @ref int8 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref int8, and must not be NULL.

    @return The new @ref int8 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC int8 DOFValueInt8_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref int16.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref int16 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref int16.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueInt16_Create( int16 val );

/**
    Create the native @ref int16 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref int16, and must not be NULL.

    @return The new @ref int16 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC int16 DOFValueInt16_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref int32.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref int32 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref int32.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueInt32_Create( int32 val );

/**
    Create the native @ref int32 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref int32, and must not be NULL.

    @return The new @ref int32 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC int32 DOFValueInt32_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref int64.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref int64 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref int64.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueInt64_Create( int64 val );

/**
    Create the native @ref int64 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref int64, and must not be NULL.

    @return The new @ref int64 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC int64 DOFValueInt64_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref uint8.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref uint8 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref uint8.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueUInt8_Create( uint8 val );

/**
    Create the native @ref uint8 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref uint8, and must not be NULL.

    @return The new @ref uint8 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint8 DOFValueUInt8_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref uint16.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref uint16 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref uint16.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueUInt16_Create( uint16 val );

/**
    Create the native @ref uint16 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref uint16, and must not be NULL.

    @return The new @ref uint16 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint16 DOFValueUInt16_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref uint32.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref uint32 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref uint32.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueUInt32_Create( uint32 val );

/**
    Create the native @ref uint32 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref uint32, and must not be NULL.

    @return The new @ref uint32 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint32 DOFValueUInt32_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref uint64.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref uint64 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref uint64.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueUInt64_Create( uint64 val );

/**
    Create the native @ref uint64 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref uint64, and must not be NULL.

    @return The new @ref uint64 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint64 DOFValueUInt64_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref float32.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref float32 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref float32.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueFloat32_Create( float32 val );

/**
    Create the native @ref float32 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref float32, and must not be NULL.

    @return The new @ref float32 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC float32 DOFValueFloat32_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref float64.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref float64 value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref float64.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueFloat64_Create( float64 val );

/**
    Create the native @ref float64 from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref float64, and must not be NULL.

    @return The new @ref float64 from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC float64 DOFValueFloat64_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref boolean.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref boolean value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref boolean.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueBoolean_Create( boolean val );

/**
    Create the native @ref boolean from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref boolean, and must not be NULL.

    @return The new @ref boolean from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC boolean DOFValueBoolean_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref DateTime.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref DateTime value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type @ref DateTime.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueDateTime_Create( DateTime val );

/**
    Create the native @ref DateTime from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref DateTime, and must not be NULL.

    @return The new @ref DateTime from the contents of @a self.

    @exception 0 is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DateTime DOFValueDateTime_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type GUID.

    @mustfree{DOFValue_Destroy}

    @param  val  The GUID value to be held by the new @ref DOFValue.

    @return The new @ref DOFValue, representing a single value of type GUID.

    @exception NULL is returned if the resulting @ref DOFValue could not be created.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueGUID_Create( GUID val );

/**
    Create the native GUID from the contents of the specified
    @ref DOFValue.

    @param  self                The DOFValue to be extracted.  This must represent a single value of type GUID, and must not be NULL.

    @return The new GUID from the contents of @a self.

    @exception {{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}} is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC GUID DOFValueGUID_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref DOFInterfaceID.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref DOFInterfaceID value to be held by the new @ref DOFValue.  This should not be NULL.

    @return The new @ref DOFValue, representing a single value of type @ref DOFInterfaceID.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueInterfaceID_Create( const DOFInterfaceID val );
/**
    Create a new @ref DOFInterfaceID from the contents of the specified
    @ref DOFValue.

    @mustfree{DOFInterfaceID_Destroy}

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref DOFInterfaceID, and must not be NULL.

    @return The new @ref DOFInterfaceID from the contents of @a self.

    @exception NULL is returned if the resulting @ref DOFInterfaceID could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFInterfaceID DOFValueInterfaceID_Extract( const DOFValue self );

/**
    Report the encapsulated @ref DOFInterfaceID data without allocation.

    @note The returned data is owned by the encapsulating @ref DOFValue, and is
    only valid in the context of that DOFValue.  It must not be freed by the
    caller.  Once the DOFValue is freed, the returned data is no longer valid.
    If the data is needed for longer than the lifetime of the DOFValue, use
    @ref DOFValueInterfaceID_Extract instead.

    @param  self  The DOFValue.  This must represent a single value of type @ref DOFInterfaceID, and must not be NULL.

    @return The encapsulated @ref DOFInterfaceID data held in the DOFValue.

    @exception NULL is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFInterfaceID DOFValueInterfaceID_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type @ref DOFObjectID.

    @mustfree{DOFValue_Destroy}

    @param  val  The @ref DOFObjectID value to be held by the new @ref DOFValue.  This should not be NULL.

    @return The new @ref DOFValue, representing a single value of type @ref DOFObjectID.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueObjectID_Create( const DOFObjectID val );
/**
    Create a new @ref DOFObjectID from the contents of the specified
    @ref DOFValue.

    @mustfree{DOFObjectID_Destroy}

    @param  self                The DOFValue to be extracted.  This must represent a single value of type @ref DOFObjectID, and must not be NULL.

    @return The new @ref DOFObjectID from the contents of @a self.

    @exception NULL is returned if the resulting @ref DOFObjectID could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFObjectID DOFValueObjectID_Extract( const DOFValue self );

/**
    Report the encapsulated @ref DOFObjectID data without allocation.

    @note The returned data is owned by the encapsulating @ref DOFValue, and is
    only valid in the context of that DOFValue.  It must not be freed by the
    caller.  Once the DOFValue is freed, the returned data is no longer valid.
    If the data is needed for longer than the lifetime of the DOFValue, use
    @ref DOFValueObjectID_Extract instead.

    @param  self  The DOFValue.  This must represent a single value of type @ref DOFObjectID, and must not be NULL.

    @return The encapsulated @ref DOFObjectID data held in the DOFValue.

    @exception NULL is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFObjectID DOFValueObjectID_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type BLOB (uint8 *).

    @mustfree{DOFValue_Destroy}

    @param  blobSize  The size of the BLOB data.
    @param  val  The BLOB (uint8 *) value to be held by the new @ref DOFValue.  This must not be NULL if @a blobSize > 0.

    @return The new @ref DOFValue, representing a single value of type BLOB (uint8 *).

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueBLOB_Create( uint32 blobSize, const uint8 * val );

/**
    Create a new BLOB (uint8 *) from the contents of the specified
    @ref DOFValue.

    @mustfree{PCRMem_Free}

    @param  self                The DOFValue to be extracted.  This must represent a single value of type BLOB (uint8 *), and must not be NULL.

    @return The new BLOB (uint8 *) from the contents of @a self.

    @exception NULL is returned if the resulting BLOB (uint8 *) could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint8 * DOFValueBLOB_Extract( const DOFValue self );

/**
    Report the encapsulated BLOB (uint8 *) data without allocation.

    @note The returned data is owned by the encapsulating @ref DOFValue, and is
    only valid in the context of that DOFValue.  It must not be freed by the
    caller.  Once the DOFValue is freed, the returned data is no longer valid.
    If the data is needed for longer than the lifetime of the DOFValue, use
    @ref DOFValueBLOB_Extract instead.

    @param  self  The DOFValue.  This must represent a single value of type BLOB (uint8 *), and must not be NULL.

    @return The encapsulated BLOB (uint8 *) data held in the DOFValue.

    @exception NULL is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC const uint8 * DOFValueBLOB_Get( const DOFValue self );

/**
    Report the size of the encapsulated BLOB (uint8 *).

    @param  self  The DOFValue.  This must represent a single value of type BLOB (uint8 *), and must not be NULL.

    @return The size of the BLOB (uint8 *) held in the DOFValue.

    @exception 0 is returned if an invalid parameter is detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint32 DOFValueBLOB_GetSize( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type Fixed-Encoding String.

    @mustfree{DOFValue_Destroy}

    @param  encoding    The MIBenum value, a unique value identifying a specific coded character set used by @a val.  This should be > 2.  Values can be found at http://www.iana.org/assignments/character-sets.  Example: @ref DOFVALUESTRING_US_ASCII.
    @param  strLength   The number of characters in @a val (used only for type compatibility).  This should be <= PCRString_Length(@a val).  This may be 0 to disable string length checking for this value.
    @param  val  The Fixed-Encoding String value to be held by the new @ref DOFValue.  This must not be NULL if @a strLength > 0.  If not NULL, the string must be NULL-terminated.

    @return The new @ref DOFValue, representing a single value of type Fixed-Encoding String.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueString_Create( uint16 encoding, uint32 strLength, const char * val );

/**
    Create a new Fixed-Encoding String from the contents of the specified
    @ref DOFValue.

    @mustfree{PCRMem_Free}

    @param  self                The DOFValue to be extracted.  This must represent a single value of type Fixed-Encoding String, and must not be NULL.

    @return The new Fixed-Encoding String from the contents of @a self.

    @exception NULL is returned if the resulting Fixed-Encoding String could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC char * DOFValueString_Extract( const DOFValue self );

/**
    Report the encapsulated Fixed-Encoding String data without allocation.

    @note The returned data is owned by the encapsulating @ref DOFValue, and is
    only valid in the context of that DOFValue.  It must not be freed by the
    caller.  Once the DOFValue is freed, the returned data is no longer valid.
    If the data is needed for longer than the lifetime of the DOFValue, use
    @ref DOFValueString_Extract instead.

    @param  self  The DOFValue.  This must represent a single value of type Fixed-Encoding String, and must not be NULL.

    @return The encapsulated Fixed-Encoding String data held in the DOFValue.

    @exception NULL is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC const char * DOFValueString_Get( const DOFValue self );

/**
    Create a new @ref DOFValue to hold a single value of type Fixed-Encoding String.

    @mustfree{DOFValue_Destroy}

    @param  encoding    The MIBenum value, a unique value identifying a specific coded character set used by @a val.  This should be > 2.
    @param  strLength   The number of characters in @a val (used only for type compatibility).  This should be <= @a bufferSize.  This may be 0 to disable string length checking for this value.
    @param  bufferSize  The number of data bytes in the buffer @a val.
    @param  val  The Fixed-Encoding String value to be held by the new @ref DOFValue.  This must not be NULL if @a bufferSize > 0.

    @return The new @ref DOFValue, representing a single value of type Fixed-Encoding String.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueString_Create_Buffer( uint16 encoding, uint32 strLength, uint32 bufferSize, const uint8 * val );

/**
    Create a new Fixed-Encoding String from the contents of the specified
    @ref DOFValue.

    @mustfree{PCRMem_Free}

    @param  self                The DOFValue to be extracted.  This must represent a single value of type Fixed-Encoding String, and must not be NULL.

    @return The new Fixed-Encoding String from the contents of @a self.

    @exception NULL is returned if the resulting Fixed-Encoding String could not be created, or an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint8 * DOFValueString_ExtractBuffer( const DOFValue self );

/**
    Report the encapsulated Fixed-Encoding String data without allocation.

    @note The returned data is owned by the encapsulating @ref DOFValue, and is
    only valid in the context of that DOFValue.  It must not be freed by the
    caller.  Once the DOFValue is freed, the returned data is no longer valid.
    If the data is needed for longer than the lifetime of the DOFValue, use
    @ref DOFValueString_Extract instead.

    @param  self  The DOFValue.  This must represent a single value of type Fixed-Encoding String, and must not be NULL.

    @return The encapsulated Fixed-Encoding String data held in the DOFValue.

    @exception NULL is returned if an invalid parameter was detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC const uint8 * DOFValueString_GetBuffer( const DOFValue self );

/**
    Report the size of the encapsulated Fixed-Encoding String.

    @param  self  The DOFValue.  This must represent a single value of type Fixed-Encoding String, and must not be NULL.

    @return The size of the Fixed-Encoding String held in the DOFValue.

    @exception 0 is returned if an invalid parameter is detected.

    @ingroup DOFValue
**/
extern DOF_OAL_DECLSPEC uint32 DOFValueString_GetBufferSize( const DOFValue self );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref int8.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref int8 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref int8 values.

    @return The new @ref DOFValue, representing an array of values of type @ref int8.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayInt8_Create( uint16 len, const int8 * val );

/**
    Create a new native array of type @ref int8 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref int8, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref int8 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC int8 * DOFValueArrayInt8_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref int16.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref int16 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref int16 values.

    @return The new @ref DOFValue, representing an array of values of type @ref int16.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayInt16_Create( uint16 len, const int16 * val );

/**
    Create a new native array of type @ref int16 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref int16, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref int16 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC int16 * DOFValueArrayInt16_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref int32.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref int32 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref int32 values.

    @return The new @ref DOFValue, representing an array of values of type @ref int32.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayInt32_Create( uint16 len, const int32 * val );

/**
    Create a new native array of type @ref int32 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref int32, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref int32 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC int32 * DOFValueArrayInt32_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref int64.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref int64 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref int64 values.

    @return The new @ref DOFValue, representing an array of values of type @ref int64.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayInt64_Create( uint16 len, const int64 * val );

/**
    Create a new native array of type @ref int64 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref int64, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref int64 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC int64 * DOFValueArrayInt64_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref uint8.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref uint8 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref uint8 values.

    @return The new @ref DOFValue, representing an array of values of type @ref uint8.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayUInt8_Create( uint16 len, const uint8 * val );

/**
    Create a new native array of type @ref uint8 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref uint8, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref uint8 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC uint8 * DOFValueArrayUInt8_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref uint16.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref uint16 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref uint16 values.

    @return The new @ref DOFValue, representing an array of values of type @ref uint16.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayUInt16_Create( uint16 len, const uint16 * val );

/**
    Create a new native array of type @ref uint16 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref uint16, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref uint16 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC uint16 * DOFValueArrayUInt16_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref uint32.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref uint32 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref uint32 values.

    @return The new @ref DOFValue, representing an array of values of type @ref uint32.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayUInt32_Create( uint16 len, const uint32 * val );

/**
    Create a new native array of type @ref uint32 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref uint32, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref uint32 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC uint32 * DOFValueArrayUInt32_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref uint64.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref uint64 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref uint64 values.

    @return The new @ref DOFValue, representing an array of values of type @ref uint64.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayUInt64_Create( uint16 len, const uint64 * val );

/**
    Create a new native array of type @ref uint64 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref uint64, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref uint64 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC uint64 * DOFValueArrayUInt64_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref float32.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref float32 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref float32 values.

    @return The new @ref DOFValue, representing an array of values of type @ref float32.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayFloat32_Create( uint16 len, const float32 * val );

/**
    Create a new native array of type @ref float32 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref float32, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref float32 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC float32 * DOFValueArrayFloat32_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref float64.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref float64 values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref float64 values.

    @return The new @ref DOFValue, representing an array of values of type @ref float64.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayFloat64_Create( uint16 len, const float64 * val );

/**
    Create a new native array of type @ref float64 from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref float64, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref float64 from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC float64 * DOFValueArrayFloat64_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref boolean.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref boolean values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref boolean values.

    @return The new @ref DOFValue, representing an array of values of type @ref boolean.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayBoolean_Create( uint16 len, const boolean * val );

/**
    Create a new native array of type @ref boolean from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref boolean, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref boolean from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC boolean * DOFValueArrayBoolean_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref DateTime.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref DateTime values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref DateTime values.

    @return The new @ref DOFValue, representing an array of values of type @ref DateTime.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayDateTime_Create( uint16 len, const DateTime * val );

/**
    Create a new native array of type @ref DateTime from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref DateTime, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of @ref DateTime from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DateTime * DOFValueArrayDateTime_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type GUID.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of GUID values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len GUID values.

    @return The new @ref DOFValue, representing an array of values of type GUID.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayGUID_Create( uint16 len, const GUID * val );

/**
    Create a new native array of type GUID from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type GUID, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of GUID from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC GUID * DOFValueArrayGUID_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type String (char *).

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of String (char *) values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len String (char *) values.
    @param  encoding The MIBenum value, a unique value identifying a specific coded character set used by all strings in @a val.  This should be > 2.  Example: @ref DOFVALUESTRING_US_ASCII.

    @return The new @ref DOFValue, representing an array of values of type String (char *).

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayString_Create( uint16 encoding, uint16 len, const char * const * val );

/**
    Create a new native array of type String (char *) from the contents of
    the specified @ref DOFValueArray.

    @mustfree{PCRMem_Free}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type String (char *), and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).  This should be less than the array length.
    @param  elementCount    The number of array elements to extract.  This should be greater than 0 and not larger than the remaining elements in the array (after @a elementOffset).

    @return The new native array of String (char *) from @a self.

    @exception NULL is returned if the native array could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC char * * DOFValueArrayString_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref DOFInterfaceID.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref DOFInterfaceID values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref DOFInterfaceID values.

    @return The new @ref DOFValue, representing an array of values of type @ref DOFInterfaceID.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayInterfaceID_Create( uint16 len, const DOFInterfaceID * val );

/**
    Create a new @ref DOFInterfaceIDList from the contents of the specified
    @ref DOFValueArray.

    @mustfree{DOFInterfaceIDList_Destroy}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref DOFInterfaceID, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).
    @param  elementCount    The number of array elements to extract.  If this number is larger than the remaining elements in the array (after @a elementOffset), the excess elements are returned as values of NULL.

    @return The new @ref DOFInterfaceIDList from the contents of @a self.

    @exception NULL is returned if the resulting @ref DOFInterfaceIDList could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFInterfaceIDList DOFValueArrayInterfaceID_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );

/**
    Create a new @ref DOFValue to hold an array of values of type @ref DOFObjectID.

    @mustfree{DOFValue_Destroy}

    @param  len  Element count of the new array.  This may be 0, and should be less than 32768.
    @param  val  Array of @ref DOFObjectID values to be held by the new @ref DOFValue.  This must not be NULL if @a len > 0, and must point to memory containing at least @a len @ref DOFObjectID values.

    @return The new @ref DOFValue, representing an array of values of type @ref DOFObjectID.

    @exception NULL is returned if the resulting @ref DOFValue could not be created, or an invalid parameter was detected.

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFValue DOFValueArrayObjectID_Create( uint16 len, const DOFObjectID * val );

/**
    Create a new @ref DOFObjectIDList from the contents of the specified
    @ref DOFValueArray.

    @mustfree{DOFObjectIDList_Destroy}

    @param  self            The DOFValue to be extracted.  This must be a DOFValueArray, must represent an array of type @ref DOFObjectID, and must not be NULL.
    @param  elementOffset   The offset of the first array element to extract (0 starts at the beginning of the array).
    @param  elementCount    The number of array elements to extract.  If this number is larger than the remaining elements in the array (after @a elementOffset), the excess elements are returned as values of NULL.

    @return The new @ref DOFObjectIDList from the contents of @a self.

    @exception NULL is returned if the resulting @ref DOFObjectIDList could not be created, or an invalid parameter was detected.

    @see    DOFValueArray_GetElementsCount

    @ingroup DOFValueArray
**/
extern DOF_OAL_DECLSPEC DOFObjectIDList DOFValueArrayObjectID_Extract( const DOFValue self, uint16 elementOffset, uint16 elementCount );



#ifdef  __cplusplus
}
#endif

#endif /* DOF_VALUE_GEN_H */
