/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef _DOF_CCMMODE_V1_H
#define _DOF_CCMMODE_V1_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <internal/blackboarddata.h>
#include <internal/channel.h>
#include <internal/packet.h>
#include <internal/securitymode.h>
#include <internal/stream.h>

#define CCMMODE_V1_APPID        0x6001

#define CCMMODE_V1_PROBE_OPCODE_DEPRECATED  0
#define CCMMODE_V1_QUERY_OPCODE             1
#define CCMMODE_V1_REQUEST_OPCODE           2
#define CCMMODE_V1_HIGHEST_OPCODE           CCMMODE_V1_REQUEST_OPCODE


typedef struct CCMMODE_V1_OperationContext_t * CCMMODE_V1_OperationContext;
typedef struct CCMMODE_V1_OperationContext_t
{
    uint32       nodeID;
} CCMMODE_V1_OperationContext_t;


typedef struct CCMMODE_V1_t
{
    BlackboardData                blackboardData;
    boolean                       isConnectionLess;
} CCMMODE_V1_t;

typedef struct CCMMODE_V1_t * CCMMODE_V1;

extern ProtocolLayerResult CCMMODE_V1_Send(CCMMODE_V1 self, DOFOperation operation, boolean isProviderOperation, DOFResult result);

extern boolean CCMMODE_V1_SM_Init(void);
extern void CCMMODE_V1_SM_Shutdown(void);
extern CCMMODE_V1 CCMMODE_V1_Create(BlackboardData blackboardData, boolean isConnectionLess);
extern void CCMMODE_V1_Destroy(CCMMODE_V1 self);
extern ProtocolLayerResult CCMMODE_V1_Receive(CCMMODE_V1 self);
extern DOFError CCMMODE_V1_SendQuery(OALChannel channel, DOFAddress address);
extern DOFError CCMMODE_V1_SendRequest(OALChannel channel, DOFAddress address);
extern DOFError CCMMODE_V1_SendRequestResponse( DOFOperation requestOp );


#ifdef  __cplusplus
}
#endif

#endif /* _DOF_CCMMODE_V1_H */




