/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_CIPHERHMACUTILS_H
#define DOF_CIPHERHMACUTILS_H


#ifdef  __cplusplus
extern "C" {
#endif


/** @internal @addtogroup OALSecureHMAC
@{
**/


#include <dof/core.h>
#include <internal/cipher.h>
#include <internal/key_request.h>


extern DOFError OALSecureHmac_CreateRequestGroupResponseMac( DOFKeyRequest keyRequest, OALStream scopeStream,
                                                             OALCryptKey KEK, OALCryptKey groupKey,
                                                             OALSecureHMACDigest digest, OALStream initialState,
                                                             uint16 epoch, uint16 appid, uint8 rank,
                                                             DOFObjectID domainID );
extern DOFError OALSecureHmac_CompleteRequestGroupResponseMac( OALSecureHMACContext * ctx, OALCryptKey groupKey,
                                                               OALSecureHMACDigest digest, OALStream initialState,
                                                               uint16 appid, uint8 rank );

extern DOFError OALSecureHmac_CreateRequestGroupResponseMac_IStream( OALCryptKey KEK, OALCryptKey groupKey, OALSecureHMACDigest digest, uint32 I_len, const uint8* I, OALStream initialState, uint16 appid, uint8 rank, DOFObjectID domainID );

/**
@}
**/


#ifdef  __cplusplus
}
#endif


#endif /* DOF_CIPHERHMACUTILS_H */

