/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_CONNECTIONLESS_REMOTECHANNEL_H
#define DOF_CONNECTIONLESS_REMOTECHANNEL_H

#include <dof/core.h>
#include <internal/connectionless_protocolstack.h>
#include <internal/channel_stack_common.h>
#include <internal/tep_v1.h>
#include <internal/trp_v1.h>

#ifdef  __cplusplus
extern "C" {
#endif

extern OALConnectionlessRemoteChannel OALConnectionlessRemoteChannel_Create(OALConnectionlessProtocolStack associatedStack,
                                                                            DTL associatedTransport,
                                                                            DOFSecurityMembrane securityConnector,
                                                                            DOFAddress address,
                                                                            DOFConnectionConfig connConfig,
                                                                            DOFServerConfig serverConfig);

extern void OALConnectionlessRemoteChannel_RemoteDomainCallback(TRP_V1_Context trp_context, void * context);
extern void OALConnectionlessRemoteChannel_ResolveCredsCallback( DOFCredentials self, DOFException exception, void* context );

extern void OALConnectionlessRemoteChannel_GetLibraryPermsCallback(DOFError           status,
                                                                   sid_t            * secureSid,
                                                                   DOFPermissionSet   libPerms,
                                                                   void             * context);

extern TEP_V1_SessionEventCallback OALConnectionlessRemoteChannel_GetSessionEventCallback(OALConnectionlessRemoteChannel self);


extern void OALConnectionlessRemoteChannel_HandleMessage_ReceiveFromTransport( OALConnectionlessRemoteChannel self,
                                                                        OALMessage message );

extern OALConnectionlessRemoteChannel OALConnectionlessStatefullRemoteChannel_Create(OALConnectionlessProtocolStack associatedStack,
                                                                     DTL associatedTransport,
                                                                     DOFSecurityMembrane securityConnector,
                                                                     DOFAddress address,
                                                                     DOFConnectionConfig connConfig,
                                                                     DOFServerConfig serverConfig);

extern TEP_V1_SessionEventCallback OALConnectionlessStatefullRemoteChannel_GetSessionEventCallback(OALConnectionlessRemoteChannel self);

#ifdef  __cplusplus
}
#endif

#endif /* DOF_CONNECTIONLESS_REMOTECHANNEL_H */
