/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_INTERNAL_ENQUEUE_H
#define DOF_INTERNAL_ENQUEUE_H

#include <dof/core.h>
#include <internal/threadpool.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @internal @addtogroup OALThreadPool
@{
**/

typedef struct OALEnqueue_t *OALEnqueue;
typedef OALThreadPoolFunc OALEnqueueFunc;

typedef struct OALEnqueueItem_t
{
    OALThreadPoolNode_t super;
    OALEnqueue          enqueue;
    OALThreadPoolFunc   userFunc;
} OALEnqueueItem_t;

typedef OALEnqueueItem_t * OALEnqueueItem;

extern OALEnqueue OALEnqueue_Create(OALThreadPool pool);
extern void OALEnqueue_Destroy(OALEnqueue enqueue);
extern void OALEnqueue_Empty(OALEnqueue enqueue);
extern boolean OALEnqueue_Enqueue(OALEnqueue     enqueue,
                                  OALEnqueueItem item);
extern boolean OALEnqueue_EnqueueInternal(OALEnqueue     enqueue,
                                          OALEnqueueItem item);

extern void OALEnqueueItem_Init(OALEnqueueItem    item,
                                OALThreadPoolFunc callback);

/**
@}
**/

#ifdef  __cplusplus
}
#endif


#endif /* _DOF_ENQUEUE_H */
