/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef _DOF_EPP_V2_H
#define _DOF_EPP_V2_H

#include <dof/core.h>
#include <internal/protocollayerresult.h>
#include <internal/stream.h>
#include <internal/packet.h>
#include <internal/blackboarddata.h>
#include <internal/queue.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @internal @addtogroup Protocols
@{
**/

/** @internal @addtogroup grp_epp_v2 EPP
@{
**/

/*
**  "Public" Type and Method Declarations
*/

/* max EPP delay value (seconds) */
#define EPPV2_DELAY_MAXSECONDS  4192
#define EPPV2_DELAY_MAXMILLISECONDS      (EPPV2_DELAY_MAXSECONDS * 1000)
#define EPPV2_VERSION           0x02


typedef struct EPP_V2_t * EPP_V2;

/* "Static" methods */

extern EPP_V2  EPP_V2_Create(BlackboardData blackboard, boolean isConnectionLess);
extern void    EPP_V2_Destroy(EPP_V2 epp);

/* "Object" methods */

extern ProtocolLayerResult EPP_V2_Receive(EPP_V2 self);
extern ProtocolLayerResult EPP_V2_Send(EPP_V2 self);

/**
@}
**/

/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* _DOF_EPP_V2_H */
