/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_INTERFACEIDINTERNAL_H
#define DOF_INTERFACEIDINTERNAL_H


#include <dof/core.h>
#include <dof/interfaceid.h>
#include <internal/stream.h>


#ifdef  __cplusplus
extern "C" {
#endif


/** @internal @addtogroup DOFInterfaceID
@{
**/

#define DOFINTERFACEID_MAX_REGISTRY_VALUE 63    /**< Maximum Interface ID registry value. **/


extern boolean             DOFInterfaceID_IsWildcard      ( const DOFInterfaceID iid );
extern DOFInterfaceID      DOFInterfaceID_Create_Unmarshal( uint32 * length, const uint8 * buffer );
extern uint8               DOFInterfaceID_Marshal         ( const DOFInterfaceID self, uint32 length, uint8 * buffer );
extern DOFInterfaceID      DOFInterfaceID_Unmarshal       ( OALStream stream );
extern boolean             DOFInterfaceID_MarshalToStream ( const DOFInterfaceID self, OALStream stream );
extern boolean             DOFInterfaceID_Init            ( void );
extern void                DOFInterfaceID_Shutdown        ( void );

extern void DOFInterfaceIDList_DestroyInterfaceIDs( DOFInterfaceIDList iid_list );

/**
@}
**/


#ifdef  __cplusplus
}
#endif


#endif /* DOF_INTERFACEIDINTERNAL_H */
