/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_INTERFACEINTERNAL_H
#define DOF_INTERFACEINTERNAL_H


#include <dof/core.h>
#include <internal/avl_tree.h>
#include <internal/type.h>


#ifdef  __cplusplus
extern "C" {
#endif


/** @internal @addtogroup DOFInterface
@{
**/


/** @internal Describes all items of a single interface. **/
typedef struct DOFInterface_t
{
    DOFInterfaceID  iid;
    OALAVLTree      itemTree;
    DOFTypeContext  typeContext;
    uint32          dataSize;
    uint32          refCount;
    uint8           data[1];
} DOFInterface_t;


#define PROPERTY_ACCESS_SIZE    1


extern boolean DOFInterface_Retain( DOFInterface_t * theInterface );


/**
@}
**/


#ifdef  __cplusplus
}
#endif


#endif /* DOF_INTERFACEINTERNAL_H */
