/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef __mutex_pool_H
#define __mutex_pool_H

#include <internal/resource_pool.h>

#ifdef  __cplusplus
extern "C" {
#endif

extern OALResourcePool mutex_pool;

#define OALMutexPool_Get(x) (PCRMutex)OALResourcePool_GetResource(mutex_pool, x)
#define OALMutexPool_GetNoRef(x) (PCRMutex)OALResourcePool_GetResourceNoRef(mutex_pool, x)
#define OALMutexPool_Release(x) OALResourcePool_ReleaseResource(mutex_pool, x)
#define OALMutexPool_Finalize(x) OALResourcePool_DestroyResource(mutex_pool, x)

#define OALMutexPool_Lock(x) PCRMutex_Lock(OALMutexPool_Get(x))
#define OALMutexPool_Unlock(x) do { PCRMutex mutex = OALMutexPool_GetNoRef(x); PCRMutex_Unlock(mutex); OALMutexPool_Release(x); } while(0)

#ifdef  __cplusplus
}
#endif

#endif
