/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef _INTERNAL_OALSTRING_H
#define _INTERNAL_OALSTRING_H

#include <dof/oal.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @internal @addtogroup OALString
@{
**/

/*
**  "Public" Type and Method Declarations
*/


extern const uint8 OALString_HexChar[];

/**
   Fill buffer hexStr with 8 converted hex characters from each nybble of the input uint32 binary value.

   @param hexStr    Pointer to destination buffer.
   @param binaryVal The input uint32 binary value.
**/
extern void OALString_Uint32ToHexString( char * hexStr, uint32 binaryVal );

#define OALString_IsSpace(c)            ((c) == 0x20 || ((c) >= 0x09 && (c) <= 0x0D))
#define OALString_IsDigit(c)            ((c) >= '0' && (c) <= '9')
#define OALString_IsHexDigit(c)         (OALString_IsDigit(c) || ((c) >= 'a' && (c) <= 'f') || ((c) >= 'A' && (c) <= 'F'))

#define OALString_HexDigitToChar(c)     (OALString_HexChar[(c)])


/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* _INTERNAL_OALSTRING_H */
