/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_OBJECTINTERNAL_H
#define DOF_OBJECTINTERNAL_H


#include <dof/core.h>
#include <internal/iteminternal.h>
#include <internal/securityscope.h>


#ifdef  __cplusplus
extern "C" {
#endif

/** @addtogroup DOFObject
@{
**/


/** Describes a DOFObject. **/
typedef struct DOFObject_t
{
    DOFObjectID oid;
    DOFSystem   sys;
    uint32      refCount;
} DOFObject_t;


/**
@}
**/


#ifdef  __cplusplus
}
#endif

#endif /* DOF_OBJECTINTERNAL_H */

