/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_OBSERVABLE_H
#define DOF_OBSERVABLE_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct OALObservable_t *OALObservable;
typedef struct OALObserver_t *OALObserver;

typedef void (*OALObserver_fn_t)(OALObserver self, OALObservable observable, void *arg);

extern void OALObservable_Init(void);
extern void OALObservable_Shutdown(void);

extern OALObservable OALObservable_Create(void);
extern void OALObservable_Destroy(OALObservable observable);

extern OALObserver OALObservable_AddObserver(OALObservable observable, OALObserver_fn_t fn, void *arg);
extern void OALObservable_RemoveObserver(OALObservable observable, OALObserver observer);

extern void OALObservable_SetChanged(OALObservable observable);
extern void OALObservable_NotifyObservers(OALObservable observable);

extern void OALObservable_SetChangedAndNotifyObservers(OALObservable observable);

#ifdef __cplusplus
}
#endif

#endif
