/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_PERMISSIONINTERNAL_H
#define DOF_PERMISSIONINTERNAL_H

#include <dof/core.h>
#include <internal/stream.h>

#ifdef  __cplusplus
extern "C" {
#endif

#define DOFPERMISSIONTYPE_BINDING_EXPLICIT 0x0007

extern DOFPermission DOFPermission_Copy( DOFPermission self );

extern boolean DOFPermission_Internal_Marshal( DOFPermission self, OALStream stream );

extern uint32 DOFPermission_MarshalByteLength( DOFPermission self );

extern DOFPermission DOFPermission_Unmarshal( OALStream stream, boolean unknownAllowed );

extern boolean DOFPermission_IsKnownType( DOFPermission self );

extern boolean DOFPermission_IsAllowedBy( DOFPermission B, DOFPermission A, boolean compareExplicit, boolean alreadyNormalized );

extern boolean DOFPermission_IsTerminal( DOFPermission self );

extern boolean DOFPermission_IsExplicit( DOFPermission self );

extern boolean DOFPermission_Intersects( DOFPermission self, DOFPermission other );

extern boolean DOFPermission_IsExpandable( DOFPermission self );

extern DOFPermissionSet DOFPermission_CreateNormalized( DOFPermission self );

extern uint32 DOFPermission_ComplementCount( DOFPermission self );

extern DOFPermissionSet DOFPermission_CreateComplement( DOFPermission self );

extern DOFPermissionSet DOFPermission_CreateExtendSet(DOFPermission self);

extern boolean DOFPermission_IsEqual( DOFPermission self, DOFPermission other );

#ifdef  __cplusplus
}
#endif

#endif

