/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_PROTOCOLLAYERRESULT_H
#define DOF_PROTOCOLLAYERRESULT_H

#include <dof/core.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @internal @addtogroup protocollayerresult
@{
**/

/*
**  "Public" Type and Method Declarations
*/

typedef uint8   ProtocolLayerResult;

#define PLRESULT_ERROR                              0x00
#define PLRESULT_NEEDMOREDATA                       0x01
#define PLRESULT_OKSENDUP                           0x02
#define PLRESULT_OKSENDDOWN                         0x03
#define PLRESULT_OKDONOTHING                        0x04
#define PLRESULT_OKNOMOREDATA                       0x05
#define PLRESULT_NEGOTIATIONCOMPLETE                0x06
#define PLRESULT_SENDDOWN_THENNEGOTIATIONCOMPLETE   0x07
#define PLRESULT_CLOSE_CONNECTION                   0x08
#define PLRESULT_SESSIONENDING                      0x09
#define PLRESULT_OKREQUEUE                          0x0A


/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* DOF_PROTOCOLLAYERRESULT_H */
