/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef _DOF_SRP_H
#define _DOF_SRP_H

#include <dof/core.h>

extern boolean OALSRP_Init(void);
extern void OALSRP_Shutdown(void);

extern boolean OALSRP_Calc_Partial_x( DOFObjectID identity, const char* password, uint8* partial_x );
extern boolean OALSRP_Calc_PublicA( uint8* privateA, uint8* pubA );
extern boolean OALSRP_Calc_v( uint8* partial_x, uint8* s, uint8* v );
extern boolean OALSRP_CalculateAS( uint8* v, uint8* pubA, uint8* pubB, uint8* srpS, uint8* Ksrp );
extern boolean OALSRP_CalculateKShared( uint8* pubA, uint8* validA, uint8* srpS, uint8* validB, uint8* KEY, uint8* Ksrp, uint32 d_len, uint8* domain, uint8* key );
extern boolean OALSRP_CalculateNode( uint8* privateA, uint8* pubA, uint8* pubB, uint8* partial_x, uint8* srps, uint8* srpS, uint8* Ksrp, uint8* validA );
extern boolean OALSRP_CalculateValidBAndKey( uint8* pubA, uint8* validA, uint8* srpS, uint8* key, uint32 d_len, uint8* domain, uint8* Ksrp, uint8* validB, uint8* KEY );

extern void    OALSRP_OALExtractKeyToBuffer( DOFObjectID objID, uint8* Ksrp, uint8* ValidA, uint8* S, uint8* PrivateA, uint8* PublicA, uint8* PublicB, uint8* srpS, uint8 lenPass, uint8* pass );
extern void    OALSRP_ExtractKeyToBuffer( uint8* Ksrp, uint8* ValidA, uint8* S, uint8* PrivateA, uint8* PublicA, uint8* PublicB, uint8* srpS, uint32 lenPass, uint8* pass );
#endif

