/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_STATICASSERTINTERNAL_H
#define DOF_STATICASSERTINTERNAL_H


#ifdef  __cplusplus
extern "C" {
#endif


/* STATIC_ASSERT( FALSE ) causes a compilation error (an array of size -1 is created).
   STATIC_ASSERT( TRUE )  compiles cleanly with no runtime overhead. */

#define STATIC_ASSERT_INNER(eval, line)     typedef int static_assert_##line[((eval) ? 1 : -1)]
#define STATIC_ASSERT_HELPER(eval, line)    STATIC_ASSERT_INNER(eval, line)
#define STATIC_ASSERT(eval)                 STATIC_ASSERT_HELPER(eval, __LINE__)


#ifdef  __cplusplus
}
#endif

#endif /* DOF_STATICASSERTINTERNAL_H */
