/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_TRANSPORTINTERNAL_H
#define DOF_TRANSPORTINTERNAL_H

#include <dof/core.h>
#include <dof/transport.h>
#include <internal/channel.h>
#include <internal/packet.h>

#ifdef  __cplusplus
extern "C" {
#endif

boolean DOFTransportLayer_Init(void);
void DOFTransportLayer_Shutdown(void);

boolean DOFTransportLayer_SendTo(DTL transport, OALPacket data, DOFAddress remoteAddr);
boolean DOFTransportLayer_CreateConnectionConfig( DTL transport, DOFAddress address, DTLConnectionConfig * DTLConfig );

boolean DTL_InitConnectionDTL( DTL self, DOF dof, OALChannel channel, DTLTransport transport, DTLConnectionConfig dtlConfig, DOFAddress peer, DOFConnectionType type );
boolean DTL_InitServerDTL( DTL self, DOF dof, OALServer server, DTLTransport transport, DTLServerConfig dtlConfig, DOFAddress listenAddr, DOFServerType type, DTL relatedServer );

DTL DTL_Create( void );
DTL DTL_Retain( DTL dtl );
void DTL_Destroy( DTL dtl );

void DTL_StopClose(DTL dtl);
void DTL_SetChannel(DTL dtl, OALChannel channel);

boolean DTL_IsConnection( DTL dtl );

/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* DOF_TRANSPORTINTERNAL_H */

