/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_TRANSPORTMANAGER_H
#define DOF_TRANSPORTMANAGER_H

#include <dof/core.h>
#include <dof/server.h>

#ifdef  __cplusplus
extern "C" {
#endif

/* @addtogroup transportmanager
@{
**/

/*
**  "Public" Type and Method Declarations
*/
extern void OALTransportManager_Init(void);
extern void OALTransportManager_Shutdown(void);

extern void OALTransportManager_AddServer(DOFServer server);
extern void OALTransportManager_RemoveServer(DOFServer server);

/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* DOF_TRANSPORTMANAGER_H */
