/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <dof/bridge.h>
#include <internal/bridgeinternal.h>

#include "bridge.h"

boolean DOFOperationBridgeConfig_Init(void)
{
    return DOFOperationBridgeConfig_SecureInit();
}

void DOFOperationBridgeConfig_Shutdown(void)
{
    DOFOperationBridgeConfig_SecureShutdown();
}

void OALOperationBridge_Ctor(OALOperationBridge         self,
                             DOFSecurityMembrane_VTable vtable)
{
    DOFSecurityMembrane_Ctor(&(self->super), vtable);
}

OALOperationBridge OALOperationBridge_Copy(OALOperationBridge self)
{
    return (OALOperationBridge) DOFSecurityMembrane_Copy(&(self->super));
}

void OALOperationBridge_Destroy(OALOperationBridge self)
{
    if (self)
    {
        DOFSecurityMembrane_Destroy(&(self->super));
    }
}

DOFSecurityMembrane DOFOperationBridgeConfig_GetMembrane(OALOperationBridge self)
{
    return &(self->super);
}
