/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_CREDENTIALS_KEY_INTERNAL_H
#define DOF_CREDENTIALS_KEY_INTERNAL_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct KEYCredentialsData_t /* Expanded Credentials for KEY */
{
    uint8               validB[40];
}KEYCredentialsData_t;

typedef struct KEYCredentials_t
{
    OALCredentials_t        base;
    KEYCredentialsData_t*   data;
    uint8                   validA[40];
    uint8                   key[32];
} KEYCredentials_t;

extern DOFCredentials KEYCredentials_InternalCreate( DOFObjectIDDomain domain );
extern DOFCredentials DOFCredentialsKey_Internal_Create( const DOFObjectIDDomain domain, const DOFObjectIDAuthentication identity, const uint8 key[32] );

#ifdef __cplusplus
}
#endif

#endif
