/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_GETITEM_H
#define DOF_GETITEM_H


#include <dof/interfaceid.h>
#include <internal/iteminternal.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @internal @addtogroup DOFInterface
    DOF Interface
@{
**/


#define DOF_MAX_INTERFACE_ITEMS     32768       /**< @internal Maximum number of items for any interface definition. **/


/** @internal
    DOFInterfaceEvent_t, DOFInterfaceMethod_t, DOFInterfaceException_t descriptors all equal DOFInterfaceProperty_t in size, etc.
    @ingroup DOFInterface
**/
typedef DOFInterfaceProperty_t itemDescriptor;


extern DOFItem DOFInterface_GetItem( const DOFInterface pInterfaceDescriptor, DOFItemID itemNumber, uint8 itemType );


/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* DOF_INTERFACEMGR_H */
