/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <dof/interfaceid.h>
#include <internal/interfaceidinternal.h>


/** @addtogroup DOFInterfaceID
@{
**/


/*
**  "Private" Methods
*/


/* @internal */
void DOFInterfaceIDList_DestroyInterfaceIDs( DOFInterfaceIDList iid_list )
{
    if (iid_list)
    {
        uint32 i;

        for (i = 0; i < iid_list->count; i++)
            DOFInterfaceID_Destroy( iid_list->list[i] );
        DOFMem_Free( iid_list->list );  /* DOFMem_Free() ignores NULL list. */
    }
}


/*
**  "Public" Methods
*/


void DOFInterfaceIDList_Destroy( DOFInterfaceIDList pIIDList )
{
    DOFInterfaceIDList_DestroyInterfaceIDs( pIIDList );
    DOFMem_Free( pIIDList );
}


/**
@}
**/
