/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef _DOF_INTERFACEIDPRIVATE_H
#define _DOF_INTERFACEIDPRIVATE_H


#include <dof/interfaceid.h>
#include <internal/objectidinternal.h>

#ifdef  __cplusplus
extern "C" {
#endif

/** @addtogroup DOFInterfaceID
    DOF Interface Identifier
@{
**/

typedef struct DOFInterfaceID_t
{
    uint32 refCount;
    uint32 identifier;
    uint8  len;         /* Actual length of iid. */
    uint8  iid[DOFINTERFACEID_MAX_SIZE];
} DOFInterfaceID_t;

/**
@}
**/

#ifdef  __cplusplus
}
#endif

#endif /* _DOF_INTERFACEIDPRIVATE_H */
