/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_OPERATIONCONFIG_STRUCT_H
#define DOF_OPERATIONCONFIG_STRUCT_H

#include <dof/core.h>

#include <internal/slist.h>
#include <internal/queue.h>
#include <internal/channel.h>

struct ProviderExclusionNode_t
{
    struct ProviderExclusionNode_t * next;
    DOFObjectID oid;
};

struct DOFOperationControl_t
{
    OALChannel       channel;
    DOFConnection    connection;

    DOFOperationRetryCallback retryCallback;
    uint32           timeout;                   /* Retry timeout. */
    uint32           ackTimeout;                /* Ignored until activated. */

    struct ProviderExclusionNode_t * exclusionQueueHead;
    struct ProviderExclusionNode_t * exclusionQueueTail;
    struct ProviderExclusionNode_t * exclusionQueueLocal;

    uint32           refCount;
    uint16           respCount;
    uint16           percentage;
    uint16           cacheDelay;
    uint8            verbosity;
    uint8            security;                 /* Nobody makes any real use of this yet. */
    unsigned int     isAutoExclusion  : 1;
    unsigned int     isAllowBroadcast : 1;
    unsigned int     isDelay          : 1;
};

#endif
