/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_CONNECTIONLESS_PROTOCOLSTACK_STRUCT_H
#define DOF_CONNECTIONLESS_PROTOCOLSTACK_STRUCT_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <internal/ccmmode_v1.h>
#include <internal/enp_v1.h>
#include <internal/epp_negative_one.h>
#include <internal/epp_v2.h>
#include <internal/oap_v1.h>
#include <internal/protocolstack.h>
#include <internal/sgmp_v1.h>
#include <internal/tep_v1.h>
#include <internal/trp_v1.h>


typedef struct OALConnectionlessProtocolStack_t
{
    OALProtocolStack_t  superClass;         /* OALConnectionlessProtocolStack inherits from the OALProtocolStack abstract class. Must always be first element in this struct. */


    /***** Protocol Layers ************************************/
    ENP_V1      enpV1;
    EPP_V2      eppV2;
    OAP_V1      oapV1;
    EPP_NegOne  eppNegOne;
    TEP_V1      tepV1;
    TRP_V1      trpV1;
    SGMP_V1     sgmpV1;
    CCMMODE_V1  ccmModeV1;
    /**********************************************************/

} OALConnectionlessProtocolStack_t;

#ifdef  __cplusplus
}
#endif


#endif /* DOF_CONNECTIONLESS_PROTOCOLSTACK_STRUCT_H */
