/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_CONNECTIONLESS_V0QUERY_H
#define DOF_CONNECTIONLESS_V0QUERY_H

#ifdef  __cplusplus
extern "C" {
#endif


#include <dof/core.h>

#include <internal/channel_stack_common.h>
#include <internal/blackboarddata.h>

typedef struct protolcolQueryNode_t
{
    OALPacket   sendPacket;
    OALChannel  channel;
    uint8       queryType;
}protocolQueryNode_t;

extern boolean OALConnectionlessProtocolStack_Handle_ENP_V0_Query(OALConnectionlessProtocolStack self,
                                                                  BlackboardData blackboardData);

extern boolean OALConnectionlessProtocolStack_handle_ENP_V0_QueryResponse(BlackboardData blackboardData);

extern boolean OALConnectionlessProtocolStack_Handle_EPP_V0_Query(OALConnectionlessProtocolStack self,
                                                                  BlackboardData blackboardData);

extern boolean OALConnectionlessProtocolStack_handle_EPP_V0_QueryResponse(BlackboardData blackboardData);

#ifdef  __cplusplus
}
#endif


#endif /* DOF_CONNECTIONLESS_V0QUERY_H */

