/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <internal/permissionsetinternal.h>
#include <internal/security_common.h>

boolean OALSessionAuthRespBlock_Unmarshal( uint8* grantedDuration, DOFSecurityScope * connSecurityScope, DOFPermissionSet initPermValidation, DOFPermissionSet respPermValidation, DOFObjectIDDomain domain, OALStream stream )
{
    if( OALStream_Read8( stream, grantedDuration ) &&
        ((*(connSecurityScope) = DOFSecurityScope_Unmarshal( stream, domain )) != NULL)&&
        DOFPermissionSet_UnmarshalValidation( initPermValidation, stream, DOFSecurityScope_GetOALPermissionScope(*connSecurityScope) ) &&
        DOFPermissionSet_UnmarshalValidation( respPermValidation, stream, DOFSecurityScope_GetOALPermissionScope(*connSecurityScope) ))
        return TRUE;
    return FALSE;
}

boolean OALSessionAuthRespBlock_Marshal( uint8 grantedDuration, DOFSecurityScope connSecurityScope, DOFPermissionSet initPermValidation, DOFPermissionSet respPermValidation, OALStream stream)
{
    if( OALStream_Write8( stream, grantedDuration ) &&
        DOFSecurityScope_Marshal( connSecurityScope, stream ) &&
        DOFPermissionSet_MarshalValidation( initPermValidation, stream ) &&
        DOFPermissionSet_MarshalValidation( respPermValidation, stream ))
        return TRUE;
    return FALSE;
}

uint32 OALSessionAuthRespBlock_MarshalByteLength( DOFSecurityScope connSecurityScope, DOFPermissionSet initPermValidation, DOFPermissionSet respPermValidation )
{
    return (1 + DOFSecurityScope_GetMarshalSize(connSecurityScope) + DOFPermissionSet_MarshalValidationSize( initPermValidation ) + DOFPermissionSet_MarshalValidationSize( respPermValidation ));
}
