/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <dof/server.h>
#include <internal/channel.h>
#include <internal/dofinternal.h>
#include <internal/serverinternal.h>

DOFSecurityMembrane DOFServer_CreateSecurityMembrane(DOF               dof,
                                                     DOFServerConfig   config)
{
    DOFOperationFilter receiveFilter = DOFServerConfig_GetReceiveFilter(config);
    DOFOperationFilter sendFilter = DOFServerConfig_GetSendFilter(config);

    if(receiveFilter == NULL)
    {
        receiveFilter = DOF_GetDefaultOperationFilter(dof);
    }
    if(sendFilter == NULL)
    {
        sendFilter = DOF_GetDefaultOperationFilter(dof);
    }
    return OALChannel_CreateSecurityMembrane(dof, receiveFilter, sendFilter, DOF_GetDefaultOperationBridge(dof));
}
