/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <dof/error.h>


/** @addtogroup DOFError
@{
**/


const char * DOFError_GetString ( const DOFError status )
{
    switch ( status )
    {
        case DOFERROR_OK: return "OK";
        case DOFERROR_NOT_SUPPORTED: return "Not Supported";
        case DOFERROR_TYPE_MISMATCH: return "Type Mismatch";
        case DOFERROR_INSUFFICIENT_RESOURCES: return "Insufficient Resources";
        case DOFERROR_TERMINATED: return "Terminated";
        case DOFERROR_REJECTED: return "Rejected";
        case DOFERROR_NOT_FOUND: return "Not Found";
        case DOFERROR_DUPLICATE: return "Duplicate";
        case DOFERROR_TOO_MANY: return "Too Many";
        case DOFERROR_APPLICATION_ERROR: return "Application Error";

        case DOFERROR_FAILED: return "Failed";
        case DOFERROR_TIMEOUT: return "Timeout";
        case DOFERROR_NOT_READABLE: return "Not Readable";
        case DOFERROR_NOT_WRITABLE: return "Not Writable";
        case DOFERROR_RESULT_LOST: return "Result Lost";
        case DOFERROR_PROTOCOL_NEGOTIATION_FAILED: return "Protocol Negotiation Failed";
        case DOFERROR_TRANSPORT_FAILED: return "Transport Failed";
        case DOFERROR_IO_FAILED: return "I/O Failed";
        case DOFERROR_AUTHENTICATION_FAILED: return "Authentication Failed";
        case DOFERROR_ACK_TIMEOUT: return "Acknowledgement Timeout";
        case DOFERROR_STALE_CREDENTIAL: return "Stale Credential";

        case DOFERROR_ACCESS_DENIED: return "Access Denied";
        case DOFERROR_UNKNOWN_INITIATOR: return "Unknown Initiator";
        case DOFERROR_UNKNOWN_RESPONDER: return "Unknown Responder";
        case DOFERROR_UNKNOWN_DOMAIN: return "Unknown Domain";
        case DOFERROR_SERVICE_UNAVAILABLE: return "Service Unavailable";
        case DOFERROR_BAD_MODE: return "Bad Mode";
        case DOFERROR_NOT_IN_GROUP: return "Not in Group";
        case DOFERROR_UNSUPPORTED_INITIATOR: return "Unsupported Initiator";
        case DOFERROR_UNSUPPORTED_RESPONDER: return "Unsupported Responder";
        case DOFERROR_INVALID_INITIATOR: return "Invalid Initiator";
        case DOFERROR_INVALID_RESPONDER: return "Invalid Responder";
        case DOFERROR_RESOLUTION_FAILED: return "Resolution Failed";
        case DOFERROR_VALIDATION_FAILED: return "Validation Failed";

        case DOFERROR_ILLEGAL_ARGUMENT: return "Illegal Argument";
        default:
        break;
    }
    return "Unknown Error";
}


/**
@}
**/
