/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <dof/core.h>
#include <internal/oalstring.h>


/** @internal @addtogroup OALString
@{
**/


const uint8 OALString_HexChar[] = { '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F' };


void OALString_Uint32ToHexString( char * hexStr, uint32 binaryVal )
{
    uint8 i;

    for (i = 0; i < 8; i++)
    {
        hexStr[7-i] = OALString_HexDigitToChar( binaryVal & 0x0f );
        binaryVal >>= 4;
    }
}


/**
@}
**/
