/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef SYSTEM_INTEREST_H
#define SYSTEM_INTEREST_H

#include <dof/core.h>
#include <dof/system.h>
#include <dof/operation.h>
#include <internal/observable.h>

#ifdef  __cplusplus
extern "C" {
#endif

extern boolean DOFSystem_CreateInterestStructure( DOFSystem system );
extern void DOFSystem_DestroyInterestStructure( DOFSystem system );

extern void DOFSystem_ProcessInterest( DOFSystem self, DOFOperation reqOp);

extern void DOFSystem_InterestOpClosing( OALObserver self, OALObservable o, void* reqOp );

#ifdef  __cplusplus
}
#endif

#endif /* SYSTEM_INTEREST_H */
