/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_SECURITY_MODE_H
#define DOF_SECURITY_MODE_H

#include <dof/oal.h>
#include <internal/stream.h>

#ifdef  __cplusplus
extern "C" {
#endif

typedef struct OALSecurityMode_t
{
    uint16  length;
    
    uint8   initialState[1];    /* must be last */
} OALSecurityMode_t;

typedef OALSecurityMode_t * OALSecurityMode;

extern OALSecurityMode OALSecurityMode_Create(uint16 length);

extern void OALSecurityMode_Destroy(OALSecurityMode self);

extern OALSecurityMode OALSecurityMode_Unmarshal(OALStream stream);

extern boolean OALSecurityMode_Marshal(OALSecurityMode self,
                                       OALStream       stream);

extern uint32 OALSecurityMode_MarshalSize(OALSecurityMode stream);

#ifdef  __cplusplus
}
#endif

#endif
