/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef TEP_V1_RECEIVEUTIL_H
#define TEP_V1_RECEIVEUTIL_H

#include "tep_v1_receiveblock.h"

#ifdef  __cplusplus
extern "C" {
#endif

typedef boolean (*TEP_V1_ReceiveUtilFunction) (TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ProcessFunctions(      TEP_V1_ReceiveBlock          block,
                                               const TEP_V1_ReceiveUtilFunction * functions);

extern boolean TEP_V1_Receive_VerifyOperation(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_LookupSession(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadDomain(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadInitiatorBlock(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadInitiatorTicket(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadTicketConfirmation(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadResponderInitialization(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadResponderBlock(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadAuthenticatorInitialization(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadInitiatorConfirmation(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_ReadErrorCode(TEP_V1_ReceiveBlock block);

extern boolean TEP_V1_Receive_VerifyInitiatorConfirmation(TEP_V1_ReceiveBlock block);

#ifdef  __cplusplus
}
#endif

#endif
