/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include "tep_v1_operation.h"
#include "tep_v1_sendblock.h"

void TEP_V1_SendBlock_Init(TEP_V1_SendBlock self,
                           TEP_V1           tep,
                           OALPacket        packet,
                           DOFOperation     operation)
{
    PCR_Assert(self != NULL);
    PCR_Assert(packet != NULL);

    PCRMem_Set(self, 0, sizeof(TEP_V1_SendBlock_t));
    self->packet = packet;
    self->tep = tep;
    self->operation = operation;
    if(operation != NULL)
    {
        self->context = (TEP_V1_OperationContext) operation->tepContext;
    }
}
