/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef TEP_V1_SENDUTIL_H
#define TEP_V1_SENDUTIL_H

#include "tep_v1_sendblock.h"

#ifdef  __cplusplus
extern "C" {
#endif

typedef boolean (*TEP_V1_SendUtilFunction) (TEP_V1_SendBlock block,
                                            boolean          write);

extern boolean TEP_V1_Send_ProcessFunctions(      TEP_V1_SendBlock          block,
                                            const TEP_V1_SendUtilFunction * functions);

extern boolean TEP_V1_Send_LookupSession(TEP_V1_SendBlock block,
                                         boolean          write);

extern boolean TEP_V1_Send_WriteFirstBytes(TEP_V1_SendBlock block,
                                           boolean          write);

extern boolean TEP_V1_Send_WriteDomain(TEP_V1_SendBlock block,
                                       boolean          write);

extern boolean TEP_V1_Send_WriteInitiatorBlock(TEP_V1_SendBlock block,
                                               boolean          write);

extern boolean TEP_V1_Send_WriteInitiatorTicket(TEP_V1_SendBlock block,
                                                boolean          write);

extern boolean TEP_V1_Send_WriteTicketConfirmation(TEP_V1_SendBlock block,
                                                   boolean          write);

extern boolean TEP_V1_Send_WriteResponderInitialization(TEP_V1_SendBlock block,
                                                        boolean          write);

extern boolean TEP_V1_Send_WriteResponderBlock(TEP_V1_SendBlock block,
                                               boolean          write);

extern boolean TEP_V1_Send_WriteAuthenticatorInitialization(TEP_V1_SendBlock block,
                                                            boolean          write);

extern boolean TEP_V1_Send_WriteInitiatorConfirmation(TEP_V1_SendBlock block,
                                                      boolean          write);

extern boolean TEP_V1_Send_WriteErrorCode(TEP_V1_SendBlock block,
                                          boolean          write);

#ifdef  __cplusplus
}
#endif
                                   
#endif
