/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef INTERNAL_QUEUE_H
#define INTERNAL_QUEUE_H

#include <internal/threadpool.h>

#ifdef  __cplusplus
extern "C" {
#endif

typedef struct InternalQueue_t
{
    OALThreadPoolItem head;
    OALThreadPoolItem tail;

    uint32            size;
} InternalQueue_t;

typedef InternalQueue_t * InternalQueue;

extern InternalQueue InternalQueue_Create(void);

extern void InternalQueue_Destroy(InternalQueue queue);

extern void InternalQueue_Enqueue(InternalQueue     queue,
                                  OALThreadPoolItem node);

extern OALThreadPoolItem InternalQueue_Dequeue(InternalQueue queue);

extern uint32 InternalQueue_GetSize(InternalQueue queue);

#ifdef  __cplusplus
}
#endif

#endif
