/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <internal/cipher.h>

#include "key_hash.h"

void shared_key_key(const uint8* key, const uint8 *mac,
                    const uint8 *session_key, uint8 *key_output)
{
    OALCryptExpandedKey ekey;
    uint32 index = 0;

    PCRMem_Copy(key_output, mac, 32);
    PCR_Validate( DOFCipherRegistry_AES256Cipher );
    DOFCipherRegistry_AES256Cipher->GenerateKeyState( ekey, key );
    DOFCipherRegistry_AES256Cipher->Encrypt( ekey, &key_output[0] );
    DOFCipherRegistry_AES256Cipher->Encrypt( ekey, &key_output[16] );

    for(; index<32; ++index)
        key_output[index] = (key_output[index] ^ session_key[index]);
}
