/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef TRP_V1_OPERATION_H
#define TRP_V1_OPERATION_H

#include <dof/core.h>
#include <internal/operationinternal.h>
#include <internal/trp_v1.h>
#include "trp_v1_utils.h"

#ifdef  __cplusplus
extern "C" {
#endif

typedef struct TRP_V1_Operation_Context_t* TRP_V1_Operation_Context;

extern DOFOperation TRP_V1_CreateOperation(DOFOperationType type, TRP_V1_Data context, DOFOperationID opID, uint32 timeout );
extern DOFOperation DOFOperation_TRP_V1_New(DOFOperationType type, TRP_V1_Data context, uint32 timeout );

#ifdef  __cplusplus
}
#endif

#endif
