/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_TRP_V1_RECEIVE_H
#define DOF_TRP_V1_RECEIVE_H

#include "trp_v1_utils.h"

#ifdef  __cplusplus
extern "C" {
#endif

typedef struct TRP_V1_ReceiveData_t
{
    TRP_V1                      trp;
    OALStream                   stream;
    DOFOperation                op;
    TRP_V1_Data_t*              opData;
}TRP_V1_ReceiveData_t;
typedef struct TRP_V1_ReceiveData_t* TRP_V1_ReceiveData;

extern void TRP_V1_CallStateMachine( DOFOperation op );
extern void TRP_V1_ReceiveInvalidOpCode( TRP_V1_ReceiveData_t data );

extern void TRP_V1_ReceiveReject( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeKEK( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestKEK( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeRandom( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestRandom( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeSession( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestSession( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeSecurityScope( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestSecurityScope( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeCredential( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestCredential( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeDomainCredential( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestDomainCredential( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeLocalDomain( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestLocalDomain( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeRemoteDomain( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestRemoteDomain( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeValidateCreds( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveRequestValidateCreds( TRP_V1_ReceiveData_t data );
extern void TRP_V1_ReceiveAuthorizeRemoteDiscover( TRP_V1_ReceiveData_t data );

#ifdef  __cplusplus
}
#endif

#endif
