/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_TRP_V1_SEND_H
#define DOF_TRP_V1_SEND_H

#ifdef  __cplusplus
extern "C" {
#endif

typedef struct TRP_V1_SendData_t
{
    TRP_V1                      trp;

    OALPacket                   packet;

    DOFResult                   result;
    DOFOperation                op;
    TRP_V1_Data_t*              opData;
}TRP_V1_SendData_t;
typedef struct TRP_V1_SendData_t* TRP_V1_SendData;

extern void TRP_V1_SendInvalidOpCode( TRP_V1_SendData_t data );
extern void TRP_V1_SendAuthorize( TRP_V1_SendData_t data );
extern void TRP_V1_SendReject( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestKEK( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestRandom( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestSession( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestSecurityScope( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestCredential( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestLocalDomain( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestRemoteDomain( TRP_V1_SendData_t opData );
extern void TRP_V1_SendRequestValidateCreds( TRP_V1_SendData_t data );

#ifdef  __cplusplus
}
#endif

#endif

