/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef TRP_V1_SM_H
#define TRP_V1_SM_H

#ifdef  __cplusplus
extern "C" {
#endif

extern void TRP_V1_SM_Call(DOFOperation op);
extern void TRP_V1_RouteSendLocal( DOFOperation op );
extern void TRP_V1_RouteReceiveLocal( DOFOperation op );
extern void TRP_V1_RouteSendLocalAS( DOFOperation op, DOFAuthenticator domain );

extern boolean TRP_V1_InitRetryTimer( void );
extern void TRP_V1_DestroyRetryTimer( void );

extern void TRP_V1_SM_ProcessInternalRequest(DOFOperation myOperation);

extern DOFOperation TRP_V1_CreateASOperation( DOFAuthenticator domain, uint8 opCode, OALChannel channel, DOFAddress addr, DOFOperationID opID );
extern void TRP_V1_ResolveDomainCredentials( DOFOperation oldOp, DOFObjectIDDomain domain, DOFCredentials creds, OALChannel channel, DOFAddress address );
extern DOFOperation TRP_V1_RelayCreate( DOFObjectIDDomain domain, OALChannel channel, DOFAddress addr, DOFOperationID opID, uint8 opCode, uint32 timeout);

extern void TRP_V1_RequestRemoteDomainDiscovery( DOFObjectIDDomain domain, DOFOperation parent, DOFKeyRequest keyReq, OALChannel channel, DOFAddress address, uint32 timeout);

typedef struct OperationContext_t
{
    OALEnqueueItem_t super;
    DOFOperation op;
    DOFAuthenticator domain;
    boolean doFree;
} OperationContext_t;

extern void TRP_V1_SM_LocalASReceive( OALThreadPoolItem dnode, boolean shutdown );

extern void TRP_V1_SM_Receive( OALThreadPoolItem dnode, boolean shutdown );
extern void TRP_V1_SM_PassThrough(DOFOperation myOperation);
extern void TRP_V1_SM_AS(DOFOperation myOperation);
extern void TRP_V1_SM_KEK(DOFOperation myOperation);
extern void TRP_V1_SM_Random(DOFOperation myOperation);
extern void TRP_V1_SM_Session(DOFOperation myOperation);
extern void TRP_V1_SM_SecurityScope(DOFOperation myOperation);
extern void TRP_V1_SM_Credential(DOFOperation myOperation);
extern void TRP_V1_SM_LocalDomain(DOFOperation myOperation);
extern void TRP_V1_SM_RemoteDomain(DOFOperation myOperation);
extern void TRP_V1_SM_ValidateCredentials(DOFOperation myOperation);

extern void TRP_V1_SM_AddConnection( DOFConnection conn );
extern void TRP_V1_SM_RemoveConnection( DOFConnection conn );
extern OALChannel TRP_V1_SM_GetConnection( DOFObjectID domain );

extern void TRP_V1_RequestLocalDomain( DOFOperation op );

#ifdef  __cplusplus
}
#endif

#endif
