#!/usr/bin/python
#
#  Copyright (c) 2010-2015, Panasonic Corporation.
#
#  Permission to use, copy, modify, and/or distribute this software for any
#  purpose with or without fee is hereby granted, provided that the above
#  copyright notice and this permission notice appear in all copies.
#
#  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
#  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
#  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
#  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
#  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
#  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

import genLevel1

#initialize the genLevel1 module
genLevel1.init('../../embunit/tools', './generation/Level1')

#get a level1 test generator
DOFValue = genLevel1.level1_generator('../../tests/Level1/DOFValue_unit.c', 'DOFValue')
DOFValue.add_include_filename('string.h')

DOFValue.add_test_generator(genLevel1.normal_generator('DOFValue_Copy_1', 'DOFValue_Copy_1.tmpl'))
DOFValue.add_test_generator(genLevel1.normal_generator('DOFValue_Copy_2', 'DOFValue_Copy_2.tmpl'))
DOFValue.add_test_generator(genLevel1.normal_generator('DOFValue_Destroy_1', 'DOFValue_Destroy_1.tmpl'))
DOFValue.add_test_generator(genLevel1.normal_generator('DOFValue_Destroy_2', 'DOFValue_Destroy_2.tmpl'))

for data in ((1, 'Int8', '100', 'DOFTYPE_INT8', '', ''), (2, 'Int16', '16000', 'DOFTYPE_INT16', '', ''), \
    (3, 'Int32', '70000', 'DOFTYPE_INT32', '', ''), (4, 'Int64', '5000000000LL', 'DOFTYPE_INT64', '', ''), \
    (5, 'UInt8', '130', 'DOFTYPE_UINT8', '', ''), (6, 'UInt16', '30000', 'DOFTYPE_UINT16', '', ''), \
    (7, 'UInt32', '0xffffffffUL', 'DOFTYPE_UINT32', '', ''), (8, 'UInt64', '0xffffffffffffffffULL', 'DOFTYPE_UINT64', '', ''), \
    (9, 'Float32', '1.0f', 'DOFTYPE_FLOAT32', '', ''), (10, 'Float64', '1.0', 'DOFTYPE_FLOAT64', '', ''), \
    (11, 'DateTime', '0', 'DOFTYPE_DATETIME', '', ''), (12, 'Boolean', 'TRUE', 'DOFTYPE_BOOLEAN', '', ''), \
    (13, 'GUID', 'guid', 'DOFTYPE_GUID', 'GUID guid = {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};', ''), \
    (14, 'InterfaceID', 'iid', 'DOFTYPE_INTERFACEID', 'DOFInterfaceID iid = DOFInterfaceID_Create(5, 0x01020304);', 'DOFInterfaceID_Destroy(iid);'), \
    (15, 'ObjectID', 'oid', 'DOFTYPE_OBJECTID', 'DOFObjectID oid = DOFObjectID_Create(DOFOBJECTIDCLASS_EMAIL, 0x0102);', 'DOFObjectID_Destroy(oid);'), \
    (16, 'String', '3, 8, "ok there"', 'DOFTYPE_STRING', '', ''), \
    (17, 'BLOB', '32, (const uint8*)"hello"', 'DOFTYPE_BLOB', '', '')):
    created = genLevel1.normal_generator('DOFValue_GetDOFType_' + str(data[0]), 'DOFValue_GetValueType.tmpl')
    created.add_replacement(genLevel1.tr_swap('@@@num@@@', str(data[0])))
    created.add_replacement(genLevel1.tr_swap('@@@type@@@', data[1]))
    created.add_replacement(genLevel1.tr_swap('@@@params@@@', data[2]))
    created.add_replacement(genLevel1.tr_swap('@@@expected@@@', data[3]))
    predata = data[4]
    if(data[4] != ''):
        predata = data[4] + '\n    '
    created.add_replacement(genLevel1.tr_swap('@@@data@@@', predata))
    postdata = data[5]
    if(data[5] != ''):
        postdata = '\n    ' + data[5]
    created.add_replacement(genLevel1.tr_swap('@@@cleanup@@@', postdata))
    DOFValue.add_test_generator(created)

DOFValue.add_test_generator(genLevel1.normal_generator('DOFValue_GetDOFType_18', 'DOFValue_GetValueType_Structure.tmpl'))
DOFValue.add_test_generator(genLevel1.normal_generator('DOFValue_GetDOFType_19', 'DOFValue_GetValueType_Array.tmpl'))

DOFValue.generate()
