#!/usr/bin/env python
#
#  Copyright (c) 2010-2015, Panasonic Corporation.
#
#  Permission to use, copy, modify, and/or distribute this software for any
#  purpose with or without fee is hereby granted, provided that the above
#  copyright notice and this permission notice appear in all copies.
#
#  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
#  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
#  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
#  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
#  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
#  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

import sys
import os


genCreateFiles = 1
genReturnFiles = 1
genTestStubs = 1
headerString = ''

outputDir = './'
inputDir = './generation/'
outputHeader = '../../include/dof/value_gen.h'

generatedFileNames = []


class MatchReplacePair:
    stringToMatch = ""
    replaceWithString = ""

class SwapMRP(MatchReplacePair):
    stringToMatch = '<SWAP>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class UnswapMRP(MatchReplacePair):
    stringToMatch = '<UNSWAP>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ValMRP(MatchReplacePair):
    stringToMatch = '<VAL>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class TypeMRP(MatchReplacePair):
    stringToMatch = '<TYPE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class IncludeMRP(MatchReplacePair):
    stringToMatch = '<INCLUDE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class SizeMRP(MatchReplacePair):
    stringToMatch = '<SIZE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class TypeSizeMRP(MatchReplacePair):
    stringToMatch = '<TYPESIZE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class CalcSizeMRP(MatchReplacePair):
    stringToMatch = '<CALCSIZE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class CalcTypeMRP(MatchReplacePair):
    stringToMatch = '<CALCTYPE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ExtraParamMRP(MatchReplacePair):
    stringToMatch = '<EXTRAPARAM>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ExtraArgMRP(MatchReplacePair):
    stringToMatch = '<EXTRAARG>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ExtraParamDoxMRP(MatchReplacePair):
    stringToMatch = '<EXTRAPARAMDOX>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class EncodingParamsMRP(MatchReplacePair):
    stringToMatch = '<ENCODINGPARAMS>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class SizeAccessorMRP(MatchReplacePair):
    stringToMatch = '<SIZEACCESSOR>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class SizeAccessCastMRP(MatchReplacePair):
    stringToMatch = '<SIZEACCESSCAST>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class TypeMixedMRP(MatchReplacePair):
    stringToMatch = '<TYPEMIXED>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class TypeUpperAllMRP(MatchReplacePair):
    stringToMatch = '<TYPEUPPER>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class RefTypeNameMRP(MatchReplacePair):
    stringToMatch = '<REFTYPENAME>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class TypeNameAllUpperMRP(MatchReplacePair):
    stringToMatch = '<TYPENAMEUPPER>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ReturnTypeMRP(MatchReplacePair):
    stringToMatch = '<RETURNTYPE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ConstReturnTypeMRP(MatchReplacePair):
    stringToMatch = '<CONSTRETURNTYPE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ConverterMRP(MatchReplacePair):
    stringToMatch = '<CONVERTER>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class UnconverterMRP(MatchReplacePair):
    stringToMatch = '<UNCONVERTER>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ConvertTypeMRP(MatchReplacePair):
    stringToMatch = '<CONVERTTYPE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ValueMRP(MatchReplacePair):
    def __init__ (self, n, replacement):
        self.stringToMatch = "<VALUE%d>" % n
        self.replaceWithString = replacement

class CompareFuncMRP(MatchReplacePair):
    stringToMatch = '<COMPAREFUNC>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ErrorReturn(MatchReplacePair):
    stringToMatch = '<ERETURN>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class DestroyMRP(MatchReplacePair):
    stringToMatch = '<DESTROY>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class DestroyValueMRP(MatchReplacePair):
    stringToMatch = '<DESTROYVALUE>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ArrayAccessorMRP(MatchReplacePair):
    stringToMatch = '<ARRAYACCESSOR>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class CountCheckMRP(MatchReplacePair):
    stringToMatch = '<COUNTCHECK>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class CreateDefMRP(MatchReplacePair):
    stringToMatch = '<CREATEDEF>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class NULLRestrictMRP(MatchReplacePair):
    stringToMatch = '<NULLRESTRICT>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ExtraArgCheckMRP(MatchReplacePair):
    stringToMatch = '<EXTRAARGCHECK>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class TypeParamMRP(MatchReplacePair):
    stringToMatch = '<TYPEPARAM>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class ExtraQualMRP(MatchReplacePair):
    stringToMatch = '<EXTRAQUAL>'
    def __init__ (self, replacement):
        self.replaceWithString = replacement

class _ExtraQualMRP(MatchReplacePair):
    stringToMatch = '<_EXTRAQUAL>'
    def __init__ (self, replacement):
        if replacement != '':
            self.replaceWithString = '_' + replacement
        else:
            self.replaceWithString = ''


class DOFValueFileGenerator:
    files = {}
    mrpList = []
    DOFTypeName = ""
    genReturn = 1

    def writeNewFileFromTemplate (self, templateFilename, newFilename, addHeader):
        global headerString
        templateFile = open(templateFilename, 'r')
        newFile = open(newFilename, 'w')
        fileString = templateFile.read()
        for mrp in self.mrpList:
            fileString = fileString.replace(mrp.stringToMatch, mrp.replaceWithString)
        newFile.write(fileString)
        generatedFileNames.append(newFilename)
        newFile.close()
        templateFile.close()
        if addHeader:
            templateFile = open(templateFilename.replace('.c.tmpl', '.h.tmpl'), 'r')
            fileString = templateFile.read()
            for mrp in self.mrpList:
                fileString = fileString.replace(mrp.stringToMatch, mrp.replaceWithString)
            headerString = headerString + fileString;
            templateFile.close()

    def createCreateFile (self):
        newFileName = outputDir + 'create' + self.DOFTypeName + '.c'
        self.writeNewFileFromTemplate(inputDir + self.files['create'], newFileName, True)

    def createReturnFile (self):
        newFileName = outputDir + 'valueTo' + self.DOFTypeName + '.c'
        self.writeNewFileFromTemplate(inputDir + self.files['return'], newFileName, True)

    def createConstReturnFile (self):
        newFileName = outputDir + 'valueGet' + self.DOFTypeName + '.c'
        self.writeNewFileFromTemplate(inputDir + self.files['returnconst'], newFileName, True)

    def createSizeFile (self):
        newFileName = outputDir + 'valueGet' + self.DOFTypeName + 'Size.c'
        self.writeNewFileFromTemplate(inputDir + self.files['size'], newFileName, True)

    def createUnitTestStub (self):
        newFileName = outputDir + 'test' + self.DOFTypeName + '_unit.c'
        self.writeNewFileFromTemplate(inputDir + self.files['unitTest'], newFileName, False)

    def generateFiles (self):
        if genCreateFiles:
            self.createCreateFile()
        if self.genReturn:
            if genReturnFiles:
                self.createReturnFile()
                if 'returnconst' in self.files:
                    self.createConstReturnFile()
                if 'size' in self.files:
                    self.createSizeFile()
        if genTestStubs:
            self.createUnitTestStub()

class SimpleTypeGenerator(DOFValueFileGenerator):
    def __init__ (self, typeStr, typeMixedStr, typeRefStr, size, convert, testVal1, testVal2, testVal3, testVal4, compareFunc, errorReturn):
        self.files = { 'create':'createSimple.c.tmpl', 'return':'returnSimple.c.tmpl', 'unitTest':'testSimple.c.tmpl' }
        self.mrpList = []
        self.mrpList.append( TypeMRP(typeStr) )
        self.mrpList.append( RefTypeNameMRP(typeRefStr) )
        self.mrpList.append( TypeMixedMRP(typeMixedStr) )
        self.mrpList.append( TypeUpperAllMRP(typeMixedStr.upper()) )
        self.mrpList.append( ErrorReturn(errorReturn) )
        if size <= 8:
            self.mrpList.append( SwapMRP('') )
            self.mrpList.append( UnswapMRP('') )
            self.mrpList.append( ValMRP('val') )
        else:
            self.mrpList.append( SwapMRP('    <CONVERTTYPE> store = PCRSwap_Net<SIZE>( <CONVERTER>val );\n') )
            self.mrpList.append( UnswapMRP('    rval = PCRSwap_Net<SIZE>( rval );\n') )
            self.mrpList.append( ValMRP('store') )
        self.mrpList.append( SizeMRP("%d" % size) )
        if convert == 0:
            self.mrpList.append( UnconverterMRP('') )
            self.mrpList.append( ConverterMRP('') )
            self.mrpList.append( ConvertTypeMRP(typeStr) )
        else:
            self.mrpList.append( UnconverterMRP('*(' + typeStr + '*)&') )
            self.mrpList.append( ConverterMRP("*(uint%d*)&" % size) )
            self.mrpList.append( ConvertTypeMRP("uint%d" % size) )
        self.mrpList.append( ValueMRP(1,testVal1) )
        self.mrpList.append( ValueMRP(2,testVal2) )
        self.mrpList.append( ValueMRP(3,testVal3) )
        self.mrpList.append( ValueMRP(4,testVal4) )
        self.mrpList.append( CompareFuncMRP(compareFunc) )
        self.mrpList.append( ExtraArgMRP('') )
        self.DOFTypeName = typeMixedStr;

class ObjectTypeGenerator(DOFValueFileGenerator):
    def __init__ (self, typeNameStr, typeStr, typeRetStr, typeCRetStr, destroyer, typeRefStr, includeStr, sizeAccessor, sizeAccessCast, lenStr, typeArg, testVal1, testVal2, testVal3, testVal4, compareFunc, staticDestroyer):
        self.files = { 'create':'createObject.c.tmpl', 'return':'returnObject.c.tmpl', 'returnconst':'returnConstObject.c.tmpl', 'unitTest':'testString.c.tmpl' }
        self.mrpList = []
        self.mrpList.append( TypeMRP(typeStr) )
        self.mrpList.append( ReturnTypeMRP(typeRetStr) )
        self.mrpList.append( ConstReturnTypeMRP(typeCRetStr) )
        self.mrpList.append( RefTypeNameMRP(typeRefStr) )
        self.mrpList.append( TypeMixedMRP(typeNameStr) )
        self.mrpList.append( TypeNameAllUpperMRP(typeNameStr.upper()) )
        self.mrpList.append( SizeMRP(lenStr) )
        self.mrpList.append( ExtraParamMRP('') )
        self.mrpList.append( ExtraParamDoxMRP('') )
        self.mrpList.append( CalcTypeMRP('    uint32 ' + lenStr + ';\n') )
        self.mrpList.append( CalcSizeMRP('    if ( !val )\n        return( NULL );\n    ' + lenStr + ' = <SIZEACCESSOR>(<SIZEACCESSCAST>val);\n') )
        self.mrpList.append( ExtraArgCheckMRP('') );
        if includeStr == '':
            self.mrpList.append( IncludeMRP('') )
        else:
            self.mrpList.append( IncludeMRP('#include <' + includeStr + '>\n') )
        self.mrpList.append( SizeAccessorMRP(sizeAccessor) )
        self.mrpList.append( SizeAccessCastMRP(sizeAccessCast) )
        self.mrpList.append( TypeSizeMRP(typeArg) )
        self.mrpList.append( ValueMRP(1,testVal1) )
        self.mrpList.append( ValueMRP(2,testVal2) )
        self.mrpList.append( ValueMRP(3,testVal3) )
        self.mrpList.append( ValueMRP(4,testVal4) )
        self.mrpList.append( CompareFuncMRP(compareFunc) )
        self.mrpList.append( ExtraArgMRP('') )
        self.mrpList.append( EncodingParamsMRP('0') )
        self.mrpList.append( DestroyMRP(destroyer) )
        self.mrpList.append( DestroyValueMRP(staticDestroyer) )
        self.mrpList.append( NULLRestrictMRP('should not be NULL') );
        self.mrpList.append( ExtraQualMRP('') )
        self.mrpList.append( _ExtraQualMRP('') )
        self.DOFTypeName = typeNameStr;

class StringTypeGenerator(DOFValueFileGenerator):
    def __init__ (self, typeNameStr, extraqual, typeStr, typeRefStr, extraArg, extraArgDox, extraArgCheck, lenStr, typeArg, setvaluedef, testVal1, testVal2, testVal3, testVal4, testExtraArg, encodingParams, genReturn):
        self.genReturn = genReturn
        if extraqual == '':
            self.files = { 'create':'createString.c.tmpl', 'return':'returnString.c.tmpl', 'returnconst':'returnConstString.c.tmpl', 'unitTest':'testBLOB.c.tmpl' }
        else:
            self.files = { 'create':'createString.c.tmpl', 'return':'returnString.c.tmpl', 'returnconst':'returnConstString.c.tmpl', 'size':'getSize.c.tmpl', 'unitTest':'testBLOB.c.tmpl' }
        self.mrpList = []
        self.mrpList.append( TypeMRP(typeStr) )
        self.mrpList.append( ReturnTypeMRP(typeStr) )
        self.mrpList.append( ConstReturnTypeMRP('const ' + typeStr) )
        self.mrpList.append( RefTypeNameMRP(typeRefStr) )
        self.mrpList.append( TypeMixedMRP(typeNameStr) )
        self.mrpList.append( TypeNameAllUpperMRP(typeNameStr.upper()) )
        self.mrpList.append( SizeMRP(lenStr) )
        self.mrpList.append( ExtraParamMRP(extraArg) )
        self.mrpList.append( ExtraParamDoxMRP(extraArgDox) )
        self.mrpList.append( CalcTypeMRP('') )
        self.mrpList.append( CalcSizeMRP('    if ( ' + lenStr + ' && !val )\n        return( NULL );\n') )
        self.mrpList.append( ExtraArgCheckMRP('    if ( ' + extraArgCheck + ' > ' + lenStr + ' )\n        return( NULL );\n') );
        self.mrpList.append( IncludeMRP('') )
        self.mrpList.append( SizeAccessorMRP('') )
        self.mrpList.append( SizeAccessCastMRP('') )
        self.mrpList.append( TypeParamMRP(typeArg) )
        self.mrpList.append( ValueMRP(1,testVal1) )
        self.mrpList.append( ValueMRP(2,testVal2) )
        self.mrpList.append( ValueMRP(3,testVal3) )
        self.mrpList.append( ValueMRP(4,testVal4) )
        self.mrpList.append( ExtraArgMRP(testExtraArg) )
        self.mrpList.append( EncodingParamsMRP(encodingParams) )
        self.mrpList.append( DestroyMRP('PCRMem_Free') )
        self.mrpList.append( DestroyValueMRP('DESTROY') )
        self.mrpList.append( CreateDefMRP(setvaluedef) )
        if lenStr == 'bufferSize' :
            self.mrpList.append( NULLRestrictMRP('must not be NULL if @a ' + lenStr + ' > 0') );
        else:
            self.mrpList.append( NULLRestrictMRP('must not be NULL if @a strLength > 0.  If not NULL, the string must be NULL-terminated') );
        self.mrpList.append( ExtraQualMRP(extraqual) )
        self.mrpList.append( _ExtraQualMRP(extraqual) )
        self.DOFTypeName = typeNameStr + extraqual;

class BLOBTypeGenerator(DOFValueFileGenerator):
    def __init__ (self, typeNameStr, typeStr, typeRefStr, extraArg, extraArgDox, lenStr, typeArg, setvaluedef, testVal1, testVal2, testVal3, testVal4, testExtraArg, encodingParams, genReturn):
        self.genReturn = genReturn
        self.files = { 'create':'createString.c.tmpl', 'return':'returnString.c.tmpl', 'returnconst':'returnConstString.c.tmpl', 'size':'getSize.c.tmpl', 'unitTest':'testBLOB.c.tmpl' }
        self.mrpList = []
        self.mrpList.append( TypeMRP(typeStr) )
        self.mrpList.append( ReturnTypeMRP(typeStr) )
        self.mrpList.append( ConstReturnTypeMRP('const ' + typeStr) )
        self.mrpList.append( RefTypeNameMRP(typeRefStr) )
        self.mrpList.append( TypeMixedMRP(typeNameStr) )
        self.mrpList.append( TypeNameAllUpperMRP(typeNameStr.upper()) )
        self.mrpList.append( SizeMRP(lenStr) )
        self.mrpList.append( ExtraParamMRP(extraArg) )
        self.mrpList.append( ExtraParamDoxMRP(extraArgDox) )
        self.mrpList.append( CalcTypeMRP('') )
        self.mrpList.append( CalcSizeMRP('    if ( ' + lenStr + ' && !val )\n        return( NULL );\n') )
        self.mrpList.append( ExtraArgCheckMRP('') );
        self.mrpList.append( IncludeMRP('') )
        self.mrpList.append( SizeAccessorMRP('') )
        self.mrpList.append( SizeAccessCastMRP('') )
        self.mrpList.append( TypeParamMRP(typeArg) )
        self.mrpList.append( ValueMRP(1,testVal1) )
        self.mrpList.append( ValueMRP(2,testVal2) )
        self.mrpList.append( ValueMRP(3,testVal3) )
        self.mrpList.append( ValueMRP(4,testVal4) )
        self.mrpList.append( ExtraArgMRP(testExtraArg) )
        self.mrpList.append( EncodingParamsMRP(encodingParams) )
        self.mrpList.append( DestroyMRP('PCRMem_Free') )
        self.mrpList.append( DestroyValueMRP('DESTROY') )
        self.mrpList.append( CreateDefMRP(setvaluedef) )
        self.mrpList.append( NULLRestrictMRP('must not be NULL if @a ' + lenStr + ' > 0') );
        self.mrpList.append( ExtraQualMRP('') )
        self.mrpList.append( _ExtraQualMRP('') )
        self.DOFTypeName = typeNameStr;

class SimpleArrayTypeGenerator(DOFValueFileGenerator):
    def __init__ (self, typeStr, typeMixedStr, typeRefStr, size, testVal1, testVal2, testVal3, testVal4, compareFunc):
        self.files = { 'create':'createArraySimple.c.tmpl', 'return':'returnArraySimple.c.tmpl', 'unitTest':'testArraySimple.c.tmpl' }
        self.mrpList = []
        self.mrpList.append( TypeMRP(typeStr) )
        self.mrpList.append( RefTypeNameMRP(typeRefStr) )
        self.mrpList.append( TypeMixedMRP(typeMixedStr) )
        self.mrpList.append( TypeUpperAllMRP(typeMixedStr.upper()) )
        self.mrpList.append( SizeMRP("%d" % size) )
        self.mrpList.append( ValueMRP(1,testVal1) )
        self.mrpList.append( ValueMRP(2,testVal2) )
        self.mrpList.append( ValueMRP(3,testVal3) )
        self.mrpList.append( ValueMRP(4,testVal4) )
        self.mrpList.append( CompareFuncMRP(compareFunc) )
        self.mrpList.append( ExtraArgMRP('') )
        self.mrpList.append( DestroyMRP('PCRMem_Free') )
        self.mrpList.append( ArrayAccessorMRP('') )
        self.mrpList.append( CountCheckMRP('') )
        self.DOFTypeName = typeMixedStr+'Array';

class StringArrayTypeGenerator(DOFValueFileGenerator):
    def __init__ (self, typeNameStr, typeStr, typeRetStr, destroyer, typeRefStr, includeStr, sizeAccessor, sizeAccessCast, typeArg, arrayAccessor, countCheck, extraParam, testVal1, testVal2, testVal3, testVal4, compareFunc, staticDestroyer, files):
        self.files = files
        self.mrpList = []
        self.mrpList.append( TypeMRP(typeStr) )
        self.mrpList.append( ReturnTypeMRP(typeRetStr) )
        self.mrpList.append( ConstReturnTypeMRP('const ' + typeStr) )
        self.mrpList.append( RefTypeNameMRP(typeRefStr) )
        self.mrpList.append( TypeMixedMRP(typeNameStr) )
        self.mrpList.append( TypeNameAllUpperMRP(typeNameStr.upper()) )
        if typeArg == '':
            self.mrpList.append( CalcTypeMRP('') )
            self.mrpList.append( CalcSizeMRP('') )
        else:
            self.mrpList.append( CalcTypeMRP('    uint32 ' + typeArg + ' = 0;\n') )
            self.mrpList.append( CalcSizeMRP('    for ( i = 0; i < len; i++ )\n        if ( val[i] )\n        {\n            uint32 tmplen = <SIZEACCESSOR>(<SIZEACCESSCAST>val[i]);\n            if ( tmplen > ' + typeArg + ' )\n                ' + typeArg + ' = tmplen;\n        }\n') )
        if includeStr == '':
            self.mrpList.append( IncludeMRP('') )
        else:
            self.mrpList.append( IncludeMRP('#include <' + includeStr + '>\n') )
        self.mrpList.append( SizeAccessorMRP(sizeAccessor) )
        self.mrpList.append( SizeAccessCastMRP(sizeAccessCast) )
        self.mrpList.append( TypeSizeMRP(typeArg) )
        self.mrpList.append( ValueMRP(1,testVal1) )
        self.mrpList.append( ValueMRP(2,testVal2) )
        self.mrpList.append( ValueMRP(3,testVal3) )
        self.mrpList.append( ValueMRP(4,testVal4) )
        self.mrpList.append( CompareFuncMRP(compareFunc) )
        self.mrpList.append( ExtraArgMRP('') )
        self.mrpList.append( ExtraParamMRP(extraParam) )
        self.mrpList.append( DestroyMRP(destroyer) )
        self.mrpList.append( DestroyValueMRP(staticDestroyer) )
        self.mrpList.append( ArrayAccessorMRP(arrayAccessor) )
        self.mrpList.append( CountCheckMRP(countCheck) )
        self.DOFTypeName = typeNameStr+'Array';


fileGenerators = []

# add the generators for all the Simple-Types
fileGenerators.append( SimpleTypeGenerator( 'int8',        'Int8',     '@ref int8',      8, 0, '0', '1', '-1', '-128', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'int16',       'Int16',    '@ref int16',    16, 0, '0', '1', '-1', '-32768', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'int32',       'Int32',    '@ref int32',    32, 0, '0', '1', '-1', '-2147483647L', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'int64',       'Int64',    '@ref int64',    64, 0, '0', '1', '-1', '-2147483649LL', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'uint8',       'UInt8',    '@ref uint8',     8, 0, '0', '1', '128', '255', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'uint16',      'UInt16',   '@ref uint16',   16, 0, '0', '1', '256', '65535', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'uint32',      'UInt32',   '@ref uint32',   32, 0, '0', '1', '0x80000000UL', '0xFFFFFFFFUL', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'uint64',      'UInt64',   '@ref uint64',   64, 0, '0', '1', '0x8000000000000000ULL', '0xFFFFFFFFFFFFFFFFULL', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'float32',     'Float32',  '@ref float32',  32, 1, '0.0f', '3.40282347e+38f', '1.17549435e-38f', '-1.2e-20f', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'float64',     'Float64',  '@ref float64',  64, 1, '0.0', '1.7976931348623157E+308', '2.2250738585072014E-308', '-1.2e-200', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'boolean',     'Boolean',  '@ref boolean',   8, 0, 'TRUE', 'FALSE', 'FALSE', 'TRUE', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'DateTime',    'DateTime', '@ref DateTime', 64, 0, '0', '1', '0x8000000000000000ULL', '0xFFFFFFFFFFFFFFFFULL', 'a==b', '0' ) )
fileGenerators.append( SimpleTypeGenerator( 'GUID',        'GUID',     'GUID',           0, 0, '{{0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f}}', '{{0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff}}', '{{0xff,0xfe,0xfd,0xfc,0xfb,0xfa,0xf9,0xf8,0xf7,0xf6,0xf5,0xf4,0xf3,0xf2,0xf1,0xf0}}', '{{0x0f,0x0e,0x0d,0x0c,0x0b,0x0a,0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00}}', 'PCRMem_Compare(&a,&b,16)==0', '{{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}}' ) )

# add the generators for all the String-Types
testInterfaceval1 = 'DOFInterfaceID_Create_Bytes( 2, (const uint8 *) "\\x01\\x00" )'
testInterfaceval2 = 'DOFInterfaceID_Create_Bytes( 2, (const uint8 *) "\\xfd\\x01" )'
testInterfaceval3 = 'DOFInterfaceID_Create_Bytes( 3, (const uint8 *) "\\xfe\\x02\\x03" )'
testInterfaceval4 = 'DOFInterfaceID_Create_Bytes( 5, (const uint8 *) "\\xff\\x04\\x05\\x06\\x07" )'
fileGenerators.append( ObjectTypeGenerator( 'InterfaceID', 'DOFInterfaceID', 'DOFInterfaceID', 'DOFInterfaceID', 'DOFInterfaceID_Destroy', '@ref DOFInterfaceID', 'dof/interfaceid.h', 'DOFInterfaceID_GetBytesSize', '', 'len', '', testInterfaceval1, testInterfaceval2, testInterfaceval3, testInterfaceval4, 'DOFInterfaceID_Compare(a,b)==0', 'DOFInterfaceID_Destroy' ) )
testObjectval1 = 'DOFObjectID_Create( DOFOBJECTIDCLASS_BROADCAST, 0, NULL )'
testObjectval2 = 'DOFObjectID_Create( DOFOBJECTIDCLASS_EMAIL, 11, (const uint8 *)"OAL@mew.com" )'
testObjectval3 = 'DOFObjectID_Create( DOFOBJECTIDCLASS_GUID, 0x3f, (const uint8 *)"\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e" )'
testObjectval4 = 'DOFObjectID_Create_Bytes( 195, (const uint8 *)"\\x80\\x80\\xbf\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x01\\x7f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e" )'
fileGenerators.append( ObjectTypeGenerator( 'ObjectID',    'DOFObjectID',    'DOFObjectID',    'DOFObjectID',    'DOFObjectID_Destroy',    '@ref DOFObjectID',    'dof/objectid.h',    'DOFObjectID_GetBytesSize',    '', 'len', '', testObjectval1, testObjectval2, testObjectval3, testObjectval4, 'DOFObjectID_Compare(a,b)==0', 'DOFObjectID_Destroy' ) )

testBLOBval1 = '10,(uint8*)"\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a"'
testBLOBval2 = '23,(uint8*)"This is a BLOB string."'
testBLOBval3 = '256,(uint8*)"\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f\\x00\\x01\\x02\\x03\\x04\\x05\\x06\\x07\\x08\\x09\\x0a\\x0b\\x0c\\x0d\\x0e\\x0f"'
testBLOBval4 = '10,(uint8*)"\\xf0\\xf1\\xf3\\xf4\\xf5\\xf6\\xf7\\xf8\\xf9\\xfa"'
fileGenerators.append( BLOBTypeGenerator( 'BLOB', 'uint8 *', 'BLOB (uint8 *)', 'uint32 blobSize, ', '    @param  blobSize  The size of the BLOB data.\n', 'blobSize', 'DOFVALUEBLOB_TYPE', '#define SETVALUE(val, s,v)  _SETVALUE(val, 0,s,s,v)\n', testBLOBval1, testBLOBval2, testBLOBval3, testBLOBval4, 'value.size, ', '0', 1 ) )

testStringval1 = '"This is a simple string."'
testStringval2 = '""'
testStringval3 = '"This is a very long string that repeats several times over and over and over again and again and again. This is a very long string that repeats several times over and over and over again and again and again. This is a very long string that repeats several times over and over and over again and again and again. This is a very long string that repeats several times over and over and over again and again and again. This is a very long string that repeats several times over and over and over again and again."'
testStringval4 = '"X"'
fileGenerators.append( StringTypeGenerator( 'String', '', 'char *',  'Fixed-Encoding String', 'uint16 encoding, uint32 strLength, ', '    @param  encoding    The MIBenum value, a unique value identifying a specific coded character set used by @a val.  This should be > 2.  Values can be found at http://www.iana.org/assignments/character-sets.  Example: @ref DOFVALUESTRING_US_ASCII.\n    @param  strLength   The number of characters in @a val (used only for type compatibility).  This should be <= PCRString_Length(@a val).  This may be 0 to disable string length checking for this value.\n', 'strLength', '( (val)? PCRString_Length(val) : 0 )', 'DOFValueStringType_Create(encoding, strLength)', '#define SETVALUE(val, v)  _SETVALUE(val, DOFVALUESTRING_US_ASCII,PCRString_Length(v),PCRString_Length(v),v)\n', testStringval1, testStringval2, testStringval3, testStringval4, 'value.encoding, value.length, ', 'encoding', 1 ) )
fileGenerators.append( StringTypeGenerator( 'String', 'Buffer', 'uint8 *', 'Fixed-Encoding String', 'uint16 encoding, uint32 strLength, uint32 bufferSize, ', '    @param  encoding    The MIBenum value, a unique value identifying a specific coded character set used by @a val.  This should be > 2.\n    @param  strLength   The number of characters in @a val (used only for type compatibility).  This should be <= @a bufferSize.  This may be 0 to disable string length checking for this value.\n    @param  bufferSize  The number of data bytes in the buffer @a val.\n', 'strLength', 'bufferSize', 'DOFValueStringType_Create(encoding, strLength)', '#define SETVALUE(val, l,v)  _SETVALUE(val, 0xFFFF,l,l,v)\n', testBLOBval1, testBLOBval2, testBLOBval3, testBLOBval4, 'value.encoding, value.length, value.size, ', 'encoding', 1 ) )

fileGenerators.append( SimpleArrayTypeGenerator( 'int8',        'Int8',     '@ref int8',      8, '0', '1', '-1', '-128', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'int16',       'Int16',    '@ref int16',    16, '0', '1', '-1', '-32768', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'int32',       'Int32',    '@ref int32',    32, '0', '1', '-1', '-2147483647L', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'int64',       'Int64',    '@ref int64',    64, '0', '1', '-1', '-2147483649LL', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'uint8',       'UInt8',    '@ref uint8',     8, '0', '1', '128', '255', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'uint16',      'UInt16',   '@ref uint16',   16, '0', '1', '256', '65535', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'uint32',      'UInt32',   '@ref uint32',   32, '0', '1', '0x80000000UL', '0xFFFFFFFFUL', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'uint64',      'UInt64',   '@ref uint64',   64, '0', '1', '0x8000000000000000ULL', '0xFFFFFFFFFFFFFFFFULL', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'float32',     'Float32',  '@ref float32',  32, '0.0f', '3.40282347e+38f', '1.17549435e-38f', '-1.2e-20f', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'float64',     'Float64',  '@ref float64',  64, '0.0', '1.7976931348623157E+308', '2.2250738585072014E-308', '-1.2e-200', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'boolean',     'Boolean',  '@ref boolean',   8, 'TRUE', 'FALSE', 'FALSE', 'TRUE', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'DateTime',    'DateTime', '@ref DateTime', 64, '0', '1', '0x8000000000000000ULL', '0xFFFFFFFFFFFFFFFFULL', 'a==b' ) )
fileGenerators.append( SimpleArrayTypeGenerator( 'GUID',        'GUID',     'GUID',           0, '{{0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f}}', '{{0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff}}', '{{0xff,0xfe,0xfd,0xfc,0xfb,0xfa,0xf9,0xf8,0xf7,0xf6,0xf5,0xf4,0xf3,0xf2,0xf1,0xf0}}', '{{0x0f,0x0e,0x0d,0x0c,0x0b,0x0a,0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00}}', 'PCRMem_Compare(&a,&b,16)==0' ) )

fileGenerators.append( StringArrayTypeGenerator( 'String', 'char * const',   'char * *',   'PCRMem_Free', 'String (char *)',          '', 'PCRString_Length', '',       'maxlen', '', '', '3, ', testStringval1, testStringval2, testStringval3, testStringval4, 'strcmp(a,b)==0', 'DESTROY', { 'create':'createArrayString.c.tmpl', 'return':'returnArrayString.c.tmpl', 'unitTest':'testArrayString.c.tmpl' } ) )
fileGenerators.append( StringArrayTypeGenerator( 'InterfaceID', 'DOFInterfaceID', 'DOFInterfaceIDList', 'DOFInterfaceIDList_Destroy', '@ref DOFInterfaceID', 'dof/interfaceid.h', 'DOFInterfaceID_GetBytesSize', '', '', '->list', '    TEST_ASSERT_EQUAL_INT(valReturned->count, i)\n', '', testInterfaceval1, testInterfaceval2, testInterfaceval3, testInterfaceval4, 'DOFInterfaceID_Compare(a,b)==0', 'DOFInterfaceID_Destroy', { 'create':'createArrayObject.c.tmpl', 'return':'returnListObject.c.tmpl', 'unitTest':'testArrayString.c.tmpl' } ) )
fileGenerators.append( StringArrayTypeGenerator( 'ObjectID',    'DOFObjectID',    'DOFObjectIDList',    'DOFObjectIDList_Destroy',    '@ref DOFObjectID',    'dof/objectid.h',    'DOFObjectID_GetBytesSize',    '', '', '->list', '    TEST_ASSERT_EQUAL_INT(valReturned->count, i)\n', '', testObjectval1, testObjectval2, testObjectval3, testObjectval4, 'DOFObjectID_Compare(a,b)==0', 'DOFObjectID_Destroy', { 'create':'createArrayObject.c.tmpl', 'return':'returnListObject.c.tmpl', 'unitTest':'testArrayString.c.tmpl' } ) )


headerFile = open(inputDir + 'header.h.tmpl', 'r')
headerString = headerFile.read()
headerFile.close()

for fg in fileGenerators:
    fg.generateFiles()

headerFile = open(inputDir + 'footer.h.tmpl', 'r')
headerString = headerString + headerFile.read()
headerFile.close()

headerFile = open(outputHeader, 'w')
headerFile.write(headerString)
generatedFileNames.append(outputHeader)
headerFile.close()

print "Created files: "
for filename in generatedFileNames:
    print "" + filename
