Description
===========

The Portable C Runtime (PCR) for POSIX provides the PCR API based on a
POSIX-compliant system environment.

----------

Build Instructions
===========

To use [CMake](http://www.cmake.org/) to build the project, create a
directory where the component will be built, and from that directory run
the following commands. (Each component will need a different directory)

- `cmake <path to component>`
- `cmake --build . --target install` [The period is required, --target install specifies that it will build and install to the default location.]

In some cases it may be necessary to specify the install location.  The first command can be replaced with the following to change the default install location:

- `cmake <path to component> -DCMAKE_INSTALL_PREFIX=<path to alternate install location>`

For more information on building this and other C-language projects, see <https://opendof.org/opendof-build-instructions-for-c/>

----------

Alternate Build Instructions
===========

Official distributions for this project are built using [Apache Ant](http://ant.apache.org/) and [Apache Ivy](http://ant.apache.org/ivy/). 
For more information see <https://opendof.org/opendof-build-process/>

----------

Build Prerequisites
===========

- dof-pcr-dev

----------

Runtime Prerequisites
===========

There are no additional runtime prerequisites, beyond the build
pre-requisites.

----------

Additional Build instructions
===========

This project supports the Cmake find\_package command. The package name for this project is `dof-pcr`. If the find\_package command is successfull the following Cmake variables will be set.

- `DOF_PCR_INCLUDE_DIRS`
- `DOF_PCR_LIBRARIES`
- `DOF_PCR_FOUND`
- `DOF_PCR_API_VERSION`

For more information see <https://opendof.org/opendof-build-instructions-for-c/>

----------

How to Report an Issue
===========

Issues can be reported through the issue tracking system of the OpenDOF
Project at <https://issue.opendof.org>

Information on the process for reporting an issue can be found at
<https://opendof.org/report-an-issue>.
