/*
**  Copyright (c) 2014-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include "config.h"
#include <dof/pcr.h>


#ifndef WORDS_BIGENDIAN

uint16 PCRSwap_Net16( uint16 value )
{
    return ( (uint16) ( ( (value) << 8          ) |
                        (((value) >> 8) & 0x00FF) ) );
}

uint32 PCRSwap_Net32( uint32 value )
{
    return ( (uint32) ( ( (value) << 24                ) |
                        (((value) <<  8) & 0x00FF0000UL) |
                        (((value) >>  8) & 0x0000FF00UL) |
                        (((value) >> 24) & 0x000000FFUL) ) );
}

uint64 PCRSwap_Net64( uint64 value )
{
    return ( (uint64) ( ( (value) << 56                         ) |
                        (((value) << 40) & 0x00FF000000000000ULL) |
                        (((value) << 24) & 0x0000FF0000000000ULL) |
                        (((value) <<  8) & 0x000000FF00000000ULL) |
                        (((value) >>  8) & 0x00000000FF000000ULL) |
                        (((value) >> 24) & 0x0000000000FF0000ULL) |
                        (((value) >> 40) & 0x000000000000FF00ULL) |
                        (((value) >> 56) & 0x00000000000000FFULL) ) );
}

#endif /* WORDS_BIGENDIAN */
