/*
**  Copyright (c) 2014-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef DOF_PCRSYNC_H
#define DOF_PCRSYNC_H

#include "config.h"
#include <dof/pcr.h>

/* Standard headers */
# include <time.h>


/** @internal @defgroup PCRSync PCRSync
    @ingroup PCR

@{
**/

/** @internal
    Get the absolute time for some number of milliseconds in the future.

    @param ms  The number of milliseconds in the future.
    @param pts Pointer to the the absolute time structure.
**/
void PCRSync_GetAbsoluteTimeFromNow( uint32 ms, struct timespec *pts );


/**
@}
**/

#endif /* DOF_PCRSYNC_H */
