/*
**  Copyright (c) 2014-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include "config.h"
#include <dof/pcr.h>
#include "pcrsync.h"

/* Standard headers */
#include <time.h>
#include <sys/time.h>


void PCRSync_GetAbsoluteTimeFromNow( uint32 ms, struct timespec *pts )
{
    struct timeval now;
    gettimeofday(&now, NULL);
    pts->tv_sec = now.tv_sec + (ms / 1000);
    pts->tv_nsec = ( now.tv_usec + ((ms % 1000) * 1000) ) * 1000;
    PCR_Assert( pts->tv_nsec <= 1998999000 );
    if (pts->tv_nsec >           999999999)
    {
        pts->tv_nsec -=         1000000000;
        ++pts->tv_sec;
    }
    PCR_Assert( pts->tv_nsec <=  999999999 ); /* Not 1 second or more. */
}

